/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export let FinancialChart = /*@__PURE__*/ (() => {
    class FinancialChart extends XYChart {
        s2(a, b, c) {
            super.s2(a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.ad2 = new FinancialChartToolbar(this, this.aij);
                    break;
                case "Toolbar":
                    let d = b;
                    if (d != null) {
                        d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ald));
                        d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.alg));
                        d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.alh));
                        d.l(null);
                    }
                    if (this.ad2 != null) {
                        this.ad2.ac = this.ad9;
                        this.ad2.ai = this.dq;
                        this.ad2.y = this.ad4;
                        this.ad2.al = this.af2;
                        if (this.ahq != null) {
                            this.ad2.l(this.ahq);
                        }
                        let e = this.ad2;
                        e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ald));
                        ;
                        let f = this.ad2;
                        f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.alg));
                        let g = this.ad2;
                        g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.alh));
                    }
                    break;
                case "ChartType":
                    if (this.ad2 != null) {
                        this.ad2.y = this.ad4;
                    }
                    break;
                case "VolumeType":
                    if (this.ad2 != null) {
                        this.ad2.ac = this.ad9;
                    }
                    break;
                case "TrendLineType":
                    if (this.ad2 != null) {
                        this.ad2.ai = this.dq;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.ad2 == null) {
                        break;
                    }
                    this.ad2.al = this.af2;
                    this.setGridRows();
                    break;
            }
        }
        alh(a, b) {
            this.ad9 = this.ad2.ac;
        }
        alg(a, b) {
            this.dq = this.ad2.ai;
        }
        ald(a, b) {
            this.ad4 = this.ad2.y;
        }
        alq() {
            this.aev = new IndicatorPane();
            this.aem = TypeRegistrar.create("FinancialLegend");
        }
        provideGrid(a) {
            this.aht = a;
            this.amb();
            this.setGridRows();
            if (this.ad2 != null) {
                this.ad2.bg(a);
            }
        }
        onDocumentClick(a) {
            if (this.ad2 != null) {
                this.ad2.bl(a);
            }
        }
        getContext() {
            let a = this.ad2.v();
            let b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.ka;
            b.toolbarContainer = this.ahq;
            b.legendContainer = this.ahp;
            b.indicatorsContainer = this.aho;
            b.volumeContainer = this.ahr;
            b.zoomContainer = this.ahs;
            return b;
        }
        provideContainer(a) {
            let b = a;
            if (b != null) {
                let c = "financialChartMainGrid";
                let d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.ad2 == null) {
                    this.ad2 = new FinancialChartToolbar(this, this.aij);
                }
                this.ad2.w.isIndicatorMenuVisible = this.aft && this.afu;
                this.ahq = b.getSubRenderer(d);
                this.ad2.l(this.ahq);
                let e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                let f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.ahp = b.getSubRenderer(f);
                let g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.aho = b.getSubRenderer(g);
                let h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.ahr = b.getSubRenderer(h);
                let i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.ahs = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.ahq = null;
                if (this.ad2 != null) {
                    this.ad2.l(null);
                }
                if (this.afk != null) {
                    this.afk.provideContainer(null);
                    this.afk = null;
                }
                if (this.aem != null) {
                    this.aem.provideContainer(null);
                }
            }
            super.provideContainer(a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.provideContainer(this.ahr);
                }
                if (this.aev != null) {
                    this.aev.h(this.aho);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.provideContainer(this.ahs);
                    if (a != null) {
                        this.akx();
                    }
                    else {
                        this.afk = null;
                    }
                }
                if (this.aem != null) {
                    this.aem.provideContainer(this.ahp);
                }
                this.setGridRows();
            }
        }
        al1(a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.provideContainer(c);
            }
            this.setGridRows();
        }
        amf(a, b) {
            this.al1(a, b, this.ahs);
            if (b == null) {
                return;
            }
            this.akx();
        }
        akx() {
            if (this.ahs == null) {
                return;
            }
            if (this.afk != null) {
                this.afk.provideContainer(null);
            }
            this.afk = TypeRegistrar.create("ZoomSlider");
            this.afk.provideContainer(this.ahs);
            let a = this.afk;
            a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
                if (this.dataChart != null) {
                    this.dataChart.t0 = new Rect(0, this.afk.windowRect.left, this.dataChart.tk.top, this.afk.windowRect.width, this.dataChart.tk.height);
                }
            });
            this.aky();
        }
        amd(a, b) {
            this.al1(a, b, this.ahr);
        }
        setGridRows() {
            if (this.aht == null) {
                return;
            }
            let a = new Array(6);
            a[0] = (this.af2 ? this.aha : 0) + "px";
            a[1] = this.afy ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.afk != null) {
                if (a[5] == "0px") {
                    this.afk.hide();
                }
                else {
                    this.afk.show();
                }
            }
            this.aht.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
            this.aht.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
            if (this.ka == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.aev != null) {
                this.aev.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.afk != null) {
                this.afk.notifySizeChanged();
            }
        }
        sb() {
            super.sb();
            this.wh = 1;
            this.abw = 0;
            this.ye = 0;
            this.acq = null;
            this.acj = AxisDefaults.g;
            this.xy = AxisDefaults.e;
            this.xx = AxisDefaults.f;
            this.ack = AxisDefaults.j;
            this.acg = null;
            this.amh = AxisDefaults.h;
            this.ahn = AxisDefaults.b;
            this.fv = true;
            this.fo = true;
            this.fp = false;
            this.a9 = 0;
            this.ib = Defaults.j;
            this.ur = Defaults.ae;
            this.um = Defaults.af;
            this.un = Defaults.ag;
            this.ix = NaN;
            this.ip = 40;
            this.f4 = true;
            this.gb = false;
            if (this.dataChart != null) {
                let a = this.dataChart.cu.j.e();
                this.add = a.d;
                this.ade = a.e;
                this.adc = a.d;
                this.amh = this.dataChart.x5;
            }
            let b = new BrushCollection();
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            let c = new BrushCollection();
            for (let d of fromEnum(b)) {
                c.add(BrushUtil.m(d, 0.3));
            }
            this.adf = c;
            this.adg = b;
        }
        alx() {
            if (this.aev != null) {
                this.aev.b = null;
                this.aev.b = this.indicatorCharts;
            }
            this.setGridRows();
        }
        aly() {
            this.setGridRows();
        }
        al7() {
            this.alx();
        }
        akw() {
            if (this.afk == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            let a = this.ka.rootWrapper.width();
            let b = this.dataChart.tz.left + this.dataChart.tz.width;
            let c = this.dataChart.tz.left;
            let d = a - b;
            this.afk.startInset = c - this.afk.trackStartInset;
            this.afk.endInset = d - this.afk.trackEndInset;
            if (this.afk.endInset < 0) {
                let e = this.afk.endInset;
                this.afk.endInset = 0;
                this.dataChart.g5 += (e * -1);
            }
            if (this.afk.startInset < 0) {
                let f = this.afk.startInset;
                this.afk.startInset = 0;
                this.dataChart.g0 += (f * -1);
            }
            this.zoomSliderChart.g0 = c;
            this.zoomSliderChart.g5 = d;
            this.zoomSliderChart.gn = this.afk.barExtent;
        }
        aln() {
            this.akw();
        }
        r8(a) {
            super.r8(a);
            if (a != null) {
                a.gm = 0;
            }
        }
        ami(a) {
            return a.td();
        }
        aml() {
            return this.ahp == null ? null : this.amk(this.ahp.rootWrapper);
        }
        amj(a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.amk(a.d.rootWrapper);
        }
        amk(a) {
            if (a == null) {
                return null;
            }
            let b = a.getOffset();
            return new Rect(0, b.left, b.top, a.width(), a.height());
        }
        ag5() {
            if (this.aht == null) {
                return NaN;
            }
            let a = this.aht.getOffset();
            return this.aht.width() + (a == null ? 0 : a.left);
        }
        sk(source_, a, b) {
            super.sk(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mp(source_, a, b);
            }
        }
        sl(source_, a, b) {
            super.sl(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mq(source_, a, b);
            }
        }
        sj(source_) {
            super.sj(source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mi(source_);
            }
        }
        sn(source_, a, b, c) {
            super.sn(source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mr(source_, a, b, c);
            }
        }
        se(a, b) {
            super.se(a, b);
            if (this.afz(a)) {
                a.toolTip = null;
            }
        }
        get ad2() {
            return this.ad1;
        }
        set ad2(a) {
            let b = this.ad2;
            if (a != b) {
                this.ad1 = a;
                this.sy("Toolbar", b, this.ad2);
            }
        }
        get aii() {
            return this.aib;
        }
        set aii(a) {
            let b = this.aii;
            if (a != b) {
                this.aib = a;
                this.sy("RangeSelectorTemplate", b, this.aii);
            }
        }
        get aij() {
            return this.aic;
        }
        set aij(a) {
            let b = this.aij;
            if (a != b) {
                this.aic = a;
                this.sy("ToolbarTemplate", b, this.aij);
            }
        }
        get aif() {
            return this.ah8;
        }
        set aif(a) {
            let b = this.aif;
            if (a != b) {
                this.ah8 = a;
                this.sy("ChartTypePickerTemplate", b, this.aif);
            }
        }
        get aik() {
            return this.aid;
        }
        set aik(a) {
            let b = this.aik;
            if (a != b) {
                this.aid = a;
                this.sy("TrendLineTypePickerTemplate", b, this.aik);
            }
        }
        get ail() {
            return this.aie;
        }
        set ail(a) {
            let b = this.ail;
            if (a != b) {
                this.aie = a;
                this.sy("VolumeTypePickerTemplate", b, this.ail);
            }
        }
        get aig() {
            return this.ah9;
        }
        set aig(a) {
            let b = this.aig;
            if (a != b) {
                this.ah9 = a;
                this.sy("IndicatorMenuTemplate", b, this.aig);
            }
        }
        get aih() {
            return this.aia;
        }
        set aih(a) {
            let b = this.aih;
            if (a != b) {
                this.aia = a;
                this.sy("OverlayPickerTemplate", b, this.aih);
            }
        }
        get afk() {
            return this.afj;
        }
        set afk(a) {
            let b = this.afk;
            if (a != b) {
                this.afj = a;
                this.sy("ZoomSlider", b, this.afk);
            }
        }
        get_ip() {
            return super.get_ip();
        }
        set_ip(a) {
            super.set_ip(a);
        }
        get_f4() {
            return super.get_f4();
        }
        set_f4(a) {
            super.set_f4(a);
        }
        get aha() {
            return this.agt;
        }
        set aha(a) {
            let b = this.aha;
            if (a != b) {
                this.agt = a;
                this.sy("ToolbarHeight", b, this.aha);
            }
        }
        constructor() {
            super();
            this.aev = null;
            this.aht = null;
            this.ahr = null;
            this.aho = null;
            this.ahq = null;
            this.ahs = null;
            this.ahp = null;
            this.ad1 = null;
            this.aib = null;
            this.aic = null;
            this.ah8 = null;
            this.aid = null;
            this.aie = null;
            this.ah9 = null;
            this.aia = null;
            this.afj = null;
            this.agt = 40;
            this.aep = null;
            this.aen = null;
            this.aer = null;
            this.aew = null;
            this.aim = null;
            this.aff = null;
            this.af5 = false;
            this.af4 = false;
            this.agc = false;
            this.afr = false;
            this.ahz = 10;
            this.ag0 = NaN;
            this.ag2 = NaN;
            this.ag1 = NaN;
            this.ag3 = 0;
            this.ad7 = 0;
            this.aea = 0;
            this.agv = 3;
            this.agy = NaN;
            this.agw = NaN;
            this.agx = NaN;
            this.agz = NaN;
            this.aec = 0;
            this.afm = true;
            this.ad3 = 0;
            this.afn = false;
            this.aeh = null;
            this.aej = null;
            this.age = null;
            this.afp = true;
            this.afo = false;
            this.afq = false;
            this.afg = null;
            this.aee = 1;
            this.ac5 = null;
            this.ac6 = null;
            this.ac7 = null;
            this.ac8 = null;
            this.ada = null;
            this.ac9 = null;
            this.ac4 = null;
            this.ac3 = null;
            this.agu = 1;
            this.ags = 1;
            this.agr = 2;
            this.agq = 1;
            this.aet = null;
            this.ahv = -2147483648;
            this.agp = 2;
            this.ahy = 3;
            this.ahw = 10;
            this.ahu = 30;
            this.ahx = 9;
            this.ady = null;
            this.adz = null;
            this.adu = null;
            this.applyCustomIndicators = null;
            this.amg = null;
            this.ag4 = 1;
            this.afl = false;
            this.ael = null;
            this.agm = dateMinValue();
            this.agl = dateMaxValue();
            this.agj = null;
            this.rt();
            this.agj = new ObservableCollection$1(Base.$, 0);
            if (this.xAxisBreaks != null) {
                let a = this.xAxisBreaks;
                a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.al5());
            }
            this.alq();
        }
        v6() {
            return this.xAxis;
        }
        v7() {
            return this.yAxis;
        }
        onAttachedToUI() {
            super.onAttachedToUI();
            if (this.afk != null) {
                this.afk.onAttachedToUI();
            }
        }
        onDetachedFromUI() {
            super.onDetachedFromUI();
            if (this.afk != null) {
                this.afk.onDetachedFromUI();
            }
        }
        bc(a) {
            return 20;
        }
        get_gt() {
            return ((() => {
                let $ret = new List$1(DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        }
        get gt() {
            return this.get_gt();
        }
        get_gs() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleFinancialPriceSeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get gs() {
            return this.get_gs();
        }
        ado(a) {
            return this.adp(a);
        }
        ae2(a) {
            return this.ae3(a);
        }
        adn(a) {
            let b = this.ado(0);
            b.name = a;
            return b;
        }
        rp() {
            this.xAxis = this.adn("xAxis");
            this.yAxis = this.ae2(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.ae2(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.adn("volumeXAxis");
            this.agg = new List$1(NumericYAxis.$, 0);
            this.agi = new List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.ae2(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.adn("indicatorXAxis_0");
            this.agg.add(this.indicatorAxis);
            this.agi.add(this.indicatorXAxis);
            if (this.xAxis.az == null) {
                this.xAxis.az = new AxisLabelSettings();
            }
            if (this.yAxis.az == null) {
                this.yAxis.az = new AxisLabelSettings();
            }
            if (this.volumeAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.volumeXAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorAxis.az == null) {
                this.indicatorAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.az == null) {
                this.indicatorXAxis.az = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.ae2(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.adn("zoomSliderXAxis");
            if (this.zoomSliderAxis.az == null) {
                this.zoomSliderAxis.az = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.az == null) {
                this.zoomSliderXAxis.az = new AxisLabelSettings();
            }
        }
        rl(a, b) {
            let c = typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.ql = this.cr(a, b);
            }
        }
        cq(a) {
            if (a != null) {
                return 1;
            }
            return super.cq(a);
        }
        ti(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.li = true;
                this.yAxis.l9 = 10;
            }
        }
        tl() {
            this.yAxis.li = this.af9;
            this.yAxis.l9 = this.ah7;
        }
        ad6(a) {
            let b;
            if (this.ad4 == 0) {
                if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.ad4;
            }
            b = this.ad5(b);
            return b;
        }
        ad5(a) {
            if ((a == 1 || a == 2)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        aef(a) {
            if ((a == 2 || a == 3)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ad8(a) {
            if (a == 2) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        aiu(a) {
            let b = a.getMemberPathFor(14);
            if (stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        }
        adp(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ae3(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ae9() {
            return this.c3(1);
        }
        afa() {
            return this.c3(0);
        }
        ae8() {
            return this.c3(2);
        }
        afb() {
            return this.c3(20);
        }
        get afs() {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        }
        get aeq() {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        }
        get afv() {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        }
        get aeo() {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get aft() {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        }
        get aes() {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get afu() {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        }
        get aex() {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        }
        c1(a, b) {
            let c = this.aiu(a);
            switch (this.ad6(a)) {
                case 3:
                    let d = this.ae9();
                    this.aeq.setValueMemberPath(d, c);
                    this.aeq.setXAxis(d, this.xAxis);
                    this.aeq.setYAxis(d, this.yAxis);
                    this.aeq.setCategoryMode(d, 1);
                    return d;
                case 4:
                    let e = this.afa();
                    this.aeq.setValueMemberPath(e, c);
                    this.aeq.setXAxis(e, this.xAxis);
                    this.aeq.setYAxis(e, this.yAxis);
                    this.aeq.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    let f = this.afb();
                    this.aeo.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.aeo.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.aeo.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.aeo.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.aeo.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.aeo.setXAxis(f, this.xAxis);
                    this.aeo.setYAxis(f, this.yAxis);
                    this.aeo.setDisplayType(f, this.ad4 == 1 ? 1 : 0);
                    this.aeo.setCategoryMode(f, 1);
                    return f;
            }
        }
        tk() {
            super.tk();
            this.all(this.xAxis);
            this.al9(false);
            if (this.ad9 != 0 && this.volumeChart != null) {
                this.als();
            }
            this.all(this.volumeXAxis);
            this.all(this.indicatorXAxis);
            this.al6();
            this.al8();
            if (this.aeg != 0) {
                this.alt();
                this.all(this.zoomSliderXAxis);
            }
        }
        abi(a, b) {
            super.abi(a, b);
            a(this.volumeXAxis);
            if (this.agi != null) {
                for (let c of fromEnum(this.agi)) {
                    a(c);
                }
            }
            let d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        }
        abn(a, b) {
            super.abn(a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.agg != null) {
                    for (let c of fromEnum(this.agg)) {
                        a(c);
                    }
                }
                a(this.zoomSliderAxis);
            }
        }
        alp(a) {
            let b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
            if (b != null) {
                a(b);
            }
        }
        abl(a) {
            super.abl(a);
            this.abc(this.volumeXAxis, a);
            this.abc(this.indicatorXAxis, a);
            this.abc(this.zoomSliderXAxis, a);
        }
        abq(a) {
            super.abq(a);
            this.abc(this.volumeAxis, a);
            this.abc(this.indicatorAxis, a);
            this.abc(this.zoomSliderAxis, a);
        }
        abo(a) {
            super.abo(a);
            this.abb(this.volumeAxis, a);
            this.abb(this.indicatorAxis, a);
            this.abb(this.zoomSliderAxis, a);
        }
        abj(a) {
            super.abj(a);
            this.abb(this.volumeXAxis, a);
            this.abb(this.indicatorXAxis, a);
            this.abb(this.zoomSliderXAxis, a);
        }
        r7(a) {
            super.r7(a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.uv = a.uy = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = this.ajp();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.ci = 2;
        }
        ajp() {
            if (this.aim == null) {
                FinancialChart.ah6++;
                this.aim = FinancialChart.ah6.toString();
            }
            return this.aim;
        }
        ak7(a, b) {
            this.akt();
            this.aln();
        }
        akt() {
            if (this.yAxis.b8()) {
                return;
            }
            let a = this.yAxis.aw.bd;
            if (this.ad9 != 0) {
                a = Math.max(a, this.volumeAxis.aw.bd);
            }
            for (let b of fromEnum(this.agg)) {
                a = Math.max(a, b.aw.bd);
            }
            this.aku(a);
        }
        aku(a) {
            if (this.yAxis.b8()) {
                return;
            }
            this.yAxis.es = this.volumeAxis.es = a;
            for (let b of fromEnum(this.agg)) {
                b.es = a;
            }
            this.zoomSliderAxis.es = this.yAxis.es;
        }
        akz(a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                let c = this.indicatorCharts._inner[b];
                for (let d = 0; d < c.series.count; d++) {
                    let e = c.series._inner[d];
                    if (!(this.afx(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        }
        ak2(a) {
            if (this.volumeChart == null) {
                return;
            }
            for (let b = 0; b < this.volumeChart.series.count; b++) {
                let c = this.volumeChart.series._inner[b];
                if (c.dd) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        }
        ak0(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (!this.afz(c)) {
                    continue;
                }
                a(c, b);
            }
        }
        ak1(a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.afz(d)) {
                    continue;
                }
                let e = this.ah0(d, c);
                a(d, e);
            }
            if (b) {
                this.ak3(a);
            }
        }
        ak3(a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
                let c = this.zoomSliderChart.series._inner[b];
                if (c.dd) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        }
        ah0(a, b) {
            if (a.cc != this.dataChart) {
                return b;
            }
            let c = this.bd == null || this.bd.dataSeries == null ? 0 : this.bd.dataSeries.count;
            let d = this.aek == null ? 0 : this.aek.count;
            return b - (c * d);
        }
        rx(a) {
            super.rx(a);
            this.ak2(a);
            this.akz(a);
            this.ak3(a);
        }
        get volumeChart() {
            return this.aff;
        }
        set volumeChart(a) {
            let b = this.volumeChart;
            if (a != b) {
                this.aff = a;
                this.sy("VolumeChart", b, this.volumeChart);
            }
        }
        als() {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            let a = new List$1(Series.$, 0);
            let b = -1;
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.afz(d) || d.dd) {
                    continue;
                }
                b++;
                let e;
                let f = this.ad9;
                f = this.ad8(f);
                switch (f) {
                    case 2:
                        e = this.afa();
                        break;
                    case 3:
                        e = this.ae8();
                        break;
                    default:
                    case 1:
                        e = this.ae9();
                        break;
                }
                this.aeq.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.aeq.setXAxis(e, this.volumeXAxis);
                this.aeq.setYAxis(e, this.volumeAxis);
                this.aeq.setValueMemberPath(e, this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > b ? this.bd.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.title = d.title + " Volume";
                e.o9 = ArrayExtension.getModulus$1(Brush.$, this.adh, b);
                e.pe = ArrayExtension.getModulus$1(Brush.$, this.adi, b);
                e.g4 = this.ahb;
                a.add(e);
            }
            let g = this.gp("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.volumeChart.series.add(i);
                this.sc(i, h);
            }
        }
        afw(a) {
            if (!this.afs) {
                return false;
            }
            return this.aeq.matchesType(a);
        }
        af0(a) {
            if (!this.afv) {
                return false;
            }
            return this.aeo.matchesType(a);
        }
        afx(a) {
            if (!this.aft) {
                return false;
            }
            return this.aes.matchesType(a);
        }
        afz(a) {
            if (!this.afu) {
                return false;
            }
            return this.aex.matchesType(a);
        }
        alr() {
            if (this.dataChart == null) {
                return;
            }
            let a = 0;
            let b = this.aei == null ? 0 : this.aei.count;
            let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let d = b + c;
            for (let e = 0; e < d; e++) {
                let f = new List$1(Series.$, 0);
                let g = this.indicatorCharts._inner[e];
                let h = e >= b;
                let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aei._inner[e]);
                let j = -1;
                for (let k = 0; k < this.dataChart.series.count; k++) {
                    let l = this.dataChart.series._inner[k];
                    if (this.afz(l) || l.dd) {
                        continue;
                    }
                    j++;
                    let m;
                    if (h) {
                        let n = this.afc("Custom");
                        this.aes.handleCustomIndicatorEvent(n, runOn(this, this.ak5));
                        m = n;
                    }
                    else {
                        m = this.afe(this.aei._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.aes.setXAxis(m, this.agi._inner[e]);
                    this.aes.setYAxis(m, this.agg._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.aes.setOpenMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(11));
                    this.aes.setHighMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(12));
                    this.aes.setLowMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(13));
                    this.aes.setCloseMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(14));
                    this.aes.setVolumeMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(15));
                    m.title = l.title + " " + i;
                    m.o9 = ArrayExtension.getModulus$1(Brush.$, this.adb, e);
                    m.g4 = this.ag7;
                    if (this.afx(m)) {
                        this.aes.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.adc, e));
                        this.aes.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aeu, e));
                    }
                    if (this.ah2 != -2147483648 && this.afx(m)) {
                        this.aes.setPeriodOverride(m, this.ah2);
                    }
                    if (this.afx(m)) {
                        this.aes.setSmoothingPeriod(m, this.ah5);
                    }
                    if (this.afx(m)) {
                        this.aes.setSignalPeriod(m, this.ah4);
                    }
                    if (this.afx(m)) {
                        this.aes.setShortPeriod(m, this.ah3);
                        this.aes.setLongPeriod(m, this.ah1);
                    }
                    this.sc(m, e);
                    f.add(m);
                }
                let o = this.gp(i, false);
                for (let p = 0; p < f.count; p++) {
                    let q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (let r = 0; r < o.count; r++) {
                        let s = o._inner[r];
                        g.series.add(s);
                        this.sc(s, r);
                    }
                }
            }
        }
        afc(indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        }
        afe(a) {
            return this.afc(EnumUtil.getName(FinancialIndicatorType_$type, a));
        }
        al9(a) {
            if (this.ad2 == null) {
                return;
            }
            let b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.ad2.as = b.actualMinimumValue;
            this.ad2.ar = b.actualMaximumValue;
            if (a) {
                this.ad2.au = b.visibleMinimum;
                this.ad2.at = b.visibleMaximum;
            }
            this.ad2.bn();
        }
        kb() {
            let a = ((() => {
                let $ret = new FinancialChartVisualData();
                $ret.mainChart = super.kb();
                $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.v7();
                $ret.toolbar = this.ad2 == null ? null : this.ad2.aj();
                $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.v7();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new List$1(Base.$, 0);
                for (let b of fromEnum(this.indicatorCharts)) {
                    a.indicatorCharts.add1(b.v7());
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.ami(this.dataChart).x;
                a.mainChartTop = this.ami(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.ami(this.volumeChart).x;
                a.volumeChartTop = this.ami(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.ami(this.zoomSliderChart).x;
                a.zoomChartTop = this.ami(this.zoomSliderChart).y;
            }
            if (this.ad2 != null) {
                let c = this.amj(this.ad2);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new List$1(Number_$type, 0);
                a.indicatorChartTops = new List$1(Number_$type, 0);
                for (let d of fromEnum(this.indicatorCharts)) {
                    a.indicatorChartLefts.add(this.ami(d).x);
                    a.indicatorChartTops.add(this.ami(d).y);
                }
            }
            let e = this.aml();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.aem == null ? null : this.aem.exportVisualData();
            return a;
        }
        air() {
            let a = this.kb();
            a.scaleByViewport();
            return a.serialize();
        }
        afd(overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        }
        al8() {
            if (this.dataChart == null) {
                return;
            }
            let a = new List$1(Series.$, 0);
            for (let b of fromEnum(this.dataChart.series)) {
                if (this.afz(b)) {
                    a.add(b);
                }
            }
            for (let c of fromEnum(a)) {
                this.dataChart.series.remove(c);
            }
            if (this.aek == null) {
                return;
            }
            let d = new List$1(Series.$, 0);
            let e = -1;
            for (let f = 0; f < this.dataChart.series.count; f++) {
                let g = this.dataChart.series._inner[f];
                if (this.afz(g) || g.dd) {
                    continue;
                }
                e++;
                for (let h = 0; h < this.aek.count; h++) {
                    let i = this.aek._inner[h];
                    let j;
                    switch (i) {
                        case 1:
                            j = this.afd(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.afd(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.aex.setXAxis(j, this.xAxis);
                    this.aex.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    let k = e * this.aek.count + h;
                    j.o9 = ArrayExtension.getModulus$1(Brush.$, this.adf, k);
                    j.pe = ArrayExtension.getModulus$1(Brush.$, this.adg, k);
                    j.g4 = this.ag9;
                    j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                    let l = g;
                    if (l == null) {
                        continue;
                    }
                    let m = this.bd.dataSeries._inner[e];
                    this.aex.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.aex.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.aex.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.aex.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.aex.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            let n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (let o = 0; o < n.length; o++) {
                n[o].index = -1;
            }
            d.o(n);
            for (let p = 0; p < d.count; p++) {
                let q = d._inner[p];
                this.dataChart.series.add(q);
                this.sc(q, p);
            }
        }
        al6() {
            if (this.af5) {
                return;
            }
            this.af5 = true;
            if (this.indicatorCharts != null) {
                let a = this.indicatorCharts;
                this.indicatorCharts = null;
                for (let b of fromEnum(a)) {
                    this.alm(b);
                }
            }
            if ((this.aei == null || this.aei.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.agg != null) {
                    this.agg.clear();
                }
                if (this.agi != null) {
                    this.agi.clear();
                }
                this.alx();
                this.al7();
                this.af5 = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.agg.clear();
            this.agi.clear();
            let c = this.aei == null ? 0 : this.aei.count;
            let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let e = c + d;
            for (let f = 0; f < e; f++) {
                let g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.alk(g);
                let h = f >= c;
                if (h) {
                    g.kl = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.kl = this.ait(this.aei._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    let i;
                    let j;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.ce) {
                            j = this.ado(0);
                        }
                        else {
                            j = this.ado(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.agg.add(i);
                    this.agi.add(j);
                    if (this.fk) {
                        this.abf(i);
                    }
                    if (this.fk) {
                        this.abd(j);
                    }
                }
            }
            this.alr();
            this.alx();
            if (this.ad2 != null) {
                this.ad2.ae = this.aei;
            }
            this.akv();
            this.al7();
            this.af5 = false;
        }
        r4() {
            super.r4();
            this.abd(this.xAxis);
            this.abd(this.volumeXAxis);
            if (this.agi != null) {
                for (let a of fromEnum(this.agi)) {
                    this.abd(a);
                }
            }
            this.abf(this.yAxis);
            this.abf(this.volumeAxis);
            if (this.agg != null) {
                for (let b of fromEnum(this.agg)) {
                    this.abf(b);
                }
            }
            this.abd(this.zoomSliderXAxis);
            this.abf(this.zoomSliderAxis);
        }
        get_ga() {
            return !this.af3;
        }
        get agb() {
            return (this.externalObject._dynamicContent);
        }
        ame(a, b) {
            this.al0(a, b);
            this.akv();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.alt();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.aly();
            this.amf(a, b);
        }
        alt() {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            let a = new List$1(Series.$, 0);
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (this.afz(c) || c.dd) {
                    continue;
                }
                let d;
                let e = this.aeg;
                e = this.aef(e);
                let f = this.ah0(c, b);
                if (e == 1) {
                    switch (this.ad6(this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.afb();
                        this.aeo.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.afb();
                        this.aeo.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.afa();
                        break;
                    case 6:
                        d = this.ae8();
                        break;
                    default:
                    case 4:
                        d = this.ae9();
                        break;
                }
                let g = this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null;
                if (d.dj && !d.ds) {
                    this.aeq.setCategoryMode(d, 1);
                    this.aeq.setXAxis(d, this.zoomSliderXAxis);
                    this.aeq.setYAxis(d, this.zoomSliderAxis);
                    this.aeq.setValueMemberPath(d, g == null ? null : this.aiu(g));
                }
                else if (d.ds) {
                    this.aeo.setCategoryMode(d, 1);
                    this.aeo.setXAxis(d, this.zoomSliderXAxis);
                    this.aeo.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.aeo.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.aeo.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.aeo.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.aeo.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.aeo.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.title = c.title;
                d.g4 = this.i3;
                a.add(d);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.sc(i, h);
            }
        }
        ss(a, b, c) {
            super.ss(a, b, c);
            if (a == null || !b) {
                return;
            }
            let d = true;
            let e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                for (let f of fromEnum(this.indicatorCharts)) {
                    a(f);
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        }
        ak5(a, b) {
            let c = b;
            let d = a;
            let e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.cc);
            }
            e -= this.aei == null ? 0 : this.aei.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        }
        al2(a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.fk) {
                this.abd(c);
            }
        }
        get aga() {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        }
        ak6(a, b) {
            this.al6();
        }
        af1(a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= timeSpanFromDays(365);
                case 2: return b >= timeSpanFromDays(180);
                case 1: return b >= timeSpanFromDays(90);
                case 0: return b >= timeSpanFromDays(30);
            }
            return false;
        }
        alw() {
            let a = this.ad0 != null ? this.ad0 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            let b = new FinancialChartRangeSelectorOptionCollection(0);
            let c = this.xAxis;
            let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            for (let e of fromEnum(a)) {
                if (this.af1(e, d)) {
                    b.add(e);
                }
            }
            this.adz = b;
            if (this.ad2 != null) {
                this.ad2.u = this.adz;
            }
        }
        ala(a, b) {
            this.alw();
        }
        alf(a, b) {
            this.aek = this.ad2.ag;
        }
        ale(a, b) {
            this.aei = this.ad2.ae;
        }
        ak8(a, b) {
            this.al6();
        }
        ak9(a, b) {
            this.al8();
        }
        alj(a, b) {
            let c = a;
            if (c.bg == null) {
                return;
            }
            if (this.af3) {
                this.alv(c.bg);
            }
        }
        alm(a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ak7));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.es = this.volumeAxis.es = this.indicatorAxis.es = 0;
                this.xAxis.az.visibility = this.ac1;
            }
        }
        alk(a) {
            let b = a != this.zoomSliderChart;
            if (b) {
                if (this.dataChart != null) {
                    a.t0 = new Rect(0, this.dataChart.tk.x, a.t0.y, this.dataChart.tk.width, a.t0.height);
                }
                let c = ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, c);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ak7));
            this.r6(a);
        }
        akv() {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.abb(this.xAxis, (a) => a.visibility = 1);
            }
            for (let a = 0; a < this.agi.count; a++) {
                let b = this.agi._inner[a];
                let c = a < this.agi.count - 1 || this.volumeChart != null;
                this.abb(b, (d) => d.visibility = c ? 1 : 0);
            }
        }
        al0(a, b) {
            if (a != null) {
                this.alm(a);
            }
            if (b != null) {
                this.alk(b);
            }
        }
        amc(a, b) {
            this.al0(a, b);
            this.akv();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.als();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.amd(a, b);
        }
        alb(a, b) {
            this.ama();
        }
        ama() {
            if (this.ad2 == null || +(this.ad2.au) == +(dateMaxValue()) || +(this.ad2.at) == +(dateMinValue()) || this.dataChart == null) {
                return;
            }
            let a = this.xAxis;
            let b = a.getWindowRectForSelection(this.ad2.au, this.ad2.at);
            if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
                return;
            }
            this.af4 = true;
            this.dataChart.t0 = new Rect(0, b.left, this.dataChart.t0.top, b.width, this.dataChart.t0.height);
            if (this.afk != null) {
                this.afk.windowRect = this.dataChart.tk;
            }
            if (this.af3) {
                this.alv(this.dataChart);
            }
            this.af4 = false;
        }
        ali(a, b) {
            this.alw();
            this.al9(!this.af4);
        }
        ak4(a, b) {
            if (!this.af4) {
                if (this.af3) {
                    this.alv(a);
                }
                let c = false;
                let d = this.s5(() => this.al9(true), c);
                c = d.p1;
                if (this.afk != null) {
                    this.afk.windowRect = this.dataChart.tk;
                }
            }
        }
        al4(a, b, c, d) {
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.af4 = true;
                a.t0 = new Rect(0, d, a.tk.top, c, a.tk.height);
                this.af4 = false;
            }
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(0, g, g, this.yAxis.ch, a.to);
            for (let i of fromEnum(a.series)) {
                h.b = i.gg();
                let j = i.ar(a.tk);
                let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                let l = b.ej(j.c, h);
                let m = b.ej(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
            let n = a.tk.width;
            if (c != -1) {
                n = c;
            }
            let o = a.tk.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
                return;
            }
            this.af4 = true;
            let p = new Rect(0, o, e, n, f - e);
            a.t0 = p;
            this.af4 = false;
        }
        al3(a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.al4(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.al4(this.volumeChart, this.volumeAxis, this.dataChart.tk.width, this.dataChart.tk.left);
                }
            }
            else if (a == this.volumeChart) {
                this.al4(this.volumeChart, this.volumeAxis, -1, -1);
                this.al4(this.dataChart, this.yAxis, this.volumeChart.tk.width, this.volumeChart.tk.left);
            }
        }
        alv(a) {
            this.s4(() => this.al3(a));
        }
        alc(a, b) {
            if (this.af3) {
                this.alv(a);
            }
        }
        amb() {
            if (!this.agb) {
                return;
            }
            this.aky();
            if (this.aeg == 0) {
                this.zoomSliderChart = null;
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((() => {
                    let $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
            }
            else {
                this.alt();
            }
        }
        aky() {
            let container_ = this.ahs.rootWrapper.getNativeElement();
            let containerParent_ = container_.parentElement;
            if (this.afk != null && containerParent_ != null && !this.agc) {
                this.agc = true;
                if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    let z_ = this.afk;
                    let f_ = this.externalObject;
                    let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                    let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        }
        al5() {
            if (this.aeb != 1) {
                return;
            }
            this.abh((a) => {
                let b;
                b = a.breaks;
                b.clear();
                if (this.xAxisBreaks == null) {
                    return;
                }
                for (let c of fromEnum(this.xAxisBreaks)) {
                    b.add(c);
                }
            });
        }
        tq(a, b, c) {
            super.tq(a, b, c);
            if (this.bd.dataSeries.count > 0) {
                if (this.aeb == 1 && stringIsNullOrEmpty(this.lo)) {
                    this.b3.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (stringIsNullOrEmpty(this.lq)) {
                    this.b3.setYMemberPath(a, this.aiu(c));
                }
                if (stringIsNullOrEmpty(this.lk)) {
                    this.b3.setLabelMemberPath(a, this.aiu(c));
                }
                if (stringIsNullOrEmpty(this.lh)) {
                    this.b3.setContentMemberPath(a, this.aiu(c));
                }
            }
        }
        ait(a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        }
        abd(a) {
            super.abd(a);
            let b = a;
            this.all(b);
            if (a.bg != null) {
                for (let c of fromEnum(a.bg.series)) {
                    if (this.afw(c)) {
                        this.aeq.setXAxis(c, b);
                    }
                    else if (this.af0(c)) {
                        this.aeo.setXAxis(c, b);
                    }
                    else if (this.afx(c)) {
                        this.aes.setXAxis(c, b);
                    }
                    else if (this.afz(c)) {
                        this.aex.setXAxis(c, b);
                    }
                }
            }
            this.alp((d) => {
                d.zoomMaximumCategoryRange = this.ahc;
                d.zoomMaximumItemSpan = this.ahd;
                d.zoomToCategoryRange = this.ahe;
                d.zoomToCategoryStart = this.ahf;
                d.zoomToItemSpan = this.ahg;
            });
            let d = a == this.zoomSliderXAxis;
            if (d) {
                a.jw = this.amh;
                a.er = this.ahn;
                this.abb(a, (e) => e.visibility = 1);
            }
            let e = a;
            e.minimumValue = this.ago;
            e.maximumValue = this.agn;
            a.b1 = this.af6;
        }
        abf(a) {
            super.abf(a);
            if (a.bg != null && a == this.yAxis) {
                for (let b of fromEnum(a.bg.series)) {
                    if (this.afw(b)) {
                        this.aeq.setYAxis(b, this.yAxis);
                    }
                    else if (this.af0(b)) {
                        this.aeo.setYAxis(b, this.yAxis);
                    }
                    else if (this.afx(b)) {
                        this.aes.setYAxis(b, this.yAxis);
                    }
                    else if (this.afz(b)) {
                        this.aex.setYAxis(b, this.yAxis);
                    }
                }
            }
            a.la = this.af7;
            a.l5 = this.ahl;
            a.l4 = this.ahk;
            if (a == this.yAxis) {
                a.l1 = this.ahj;
            }
            let c = a == this.zoomSliderAxis;
            if (c) {
                this.abb(a, (d) => d.visibility = 1);
            }
            a.b1 = this.af8;
        }
        all(a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.f0 = XYChart.y0(a, this.bd.dataSeries);
            if (this.bd.dataSeries.count > 0) {
                let b = this.bd.dataSeries._inner[0].getMemberPathFor(17);
                a.hy(b);
            }
        }
        sc(a, b) {
            super.sc(a, b);
            if (a == null) {
                return;
            }
            let c = this.zoomSliderChart == a.cc;
            let d = this.dataChart != null && this.dataChart.series.contains(a);
            if ((d || c) && a.d6) {
                a.ms(this.add != null ? ArrayExtension.getModulus$1(Brush.$, this.add, b) : null, this.ade != null ? ArrayExtension.getModulus$1(Brush.$, this.ade, b) : null);
            }
            let e = this.afx(a);
            if (this.afz(a)) {
                a.o9 = this.adf != null ? ArrayExtension.getModulus$1(Brush.$, this.adf, b) : null;
                a.pe = this.adg != null ? ArrayExtension.getModulus$1(Brush.$, this.adg, b) : null;
                a.g4 = this.ag9;
            }
            else if (e) {
                a.o9 = this.adb != null ? ArrayExtension.getModulus$1(Brush.$, this.adb, b) : null;
                a.g4 = this.ag7;
            }
            else if (!a.dd && (d || c)) {
                a.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, b) : null;
                a.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, b) : null;
            }
            let f = this.volumeChart != null && this.volumeChart == a.cc;
            if (f) {
                a.g4 = this.ahb;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.afy ? this.aem : null;
        }
        sy(a, b, c) {
            super.sy(a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.li = this.af9;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.li = this.af9;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.li = this.af9;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.l9 = this.ah7;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.l9 = this.ah7;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.l9 = this.ah7;
                    }
                    break;
                case "VolumeType":
                    let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.ad9 == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((() => {
                            let $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.als();
                    }
                    break;
                case "VolumeChart":
                    this.amc(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (typeCast(XamDataChart.$, b) !== null) {
                        let e = b;
                        e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ak7));
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ak4));
                        e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.alc));
                    }
                    if (this.dataChart != null) {
                        let f = this.dataChart;
                        f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ak7));
                        let g = this.dataChart;
                        g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ak4));
                        let h = this.dataChart;
                        h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.alc));
                    }
                    this.amb();
                    break;
                case "XAxisMode":
                    this.xAxis = this.ado(this.aeb);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.ado(this.aeb);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.ado(this.aeb);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.ado(this.aeb);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.abb(this.zoomSliderXAxis, (i) => i.visibility = 1);
                    this.akv();
                    if (this.aeb == 1) {
                        this.al5();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.ae2(this.aed);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.ae2(this.aed);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.ae2(this.aed);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    let i = typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.alb));
                        i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ale));
                        i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.alf));
                    }
                    if (this.ad2 != null) {
                        this.ad2.ae = this.aei;
                        this.ad2.ag = this.aek;
                        this.ad2.u = this.adz;
                        this.al9(true);
                        let j = this.ad2;
                        j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.alb));
                        let k = this.ad2;
                        k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ale));
                        let l = this.ad2;
                        l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.alf));
                    }
                    break;
                case "XAxis":
                    let m = typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.ali));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.fk) {
                        this.abd(this.xAxis);
                        this.ru();
                    }
                    this.al9(false);
                    this.ama();
                    this.alw();
                    let o = this.xAxis;
                    o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.ali));
                    break;
                case "XAxisZoomMaximumCategoryRange":
                    this.alp((p) => p.zoomMaximumCategoryRange = this.ahc);
                    break;
                case "XAxisZoomMaximumItemSpan":
                    this.alp((p) => p.zoomMaximumItemSpan = this.ahd);
                    break;
                case "XAxisZoomToCategoryRange":
                    this.alp((p) => p.zoomToCategoryRange = this.ahe);
                    break;
                case "XAxisZoomToCategoryStart":
                    this.alp((p) => p.zoomToCategoryStart = this.ahf);
                    break;
                case "XAxisZoomToItemSpan":
                    this.alp((p) => p.zoomToItemSpan = this.ahg);
                    break;
                case "ChartType":
                    this.tk();
                    break;
                case "VolumeXAxis":
                    this.al2(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.al2(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.al6();
                    break;
                case "YAxis":
                    let p = typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.fk) {
                        this.abf(this.yAxis);
                        this.abf(this.yAxis);
                    }
                    let q = this.yAxis;
                    q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.alj));
                    break;
                case "VolumeAxis":
                    let r = typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.als();
                    }
                    if (this.fk) {
                        this.abf(this.volumeAxis);
                    }
                    let s = this.volumeAxis;
                    s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.alj));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (let t = 0; t < this.indicatorCharts.count; t++) {
                            let u = this.indicatorCharts._inner[t];
                            let v = new List$1(Axis.$, 0);
                            for (let w of fromEnum(u.axes)) {
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                            for (let x of fromEnum(v)) {
                                u.axes.remove(x);
                            }
                            let y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.aed == 1) {
                                y = this.ae2(this.aed);
                            }
                            else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.fk) {
                                this.abf(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.uy = this.gb && this.ga;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.uy = this.gb && this.ga;
                    }
                    if (this.af3) {
                        this.al3(this.dataChart);
                    }
                    else {
                        this.volumeChart.v5 = 1;
                    }
                    break;
                case "IndicatorTypes":
                    let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ak8));
                    }
                    let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ak8));
                    }
                    this.al6();
                    break;
                case "OverlayTypes":
                    let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ak9));
                    }
                    let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ak9));
                    }
                    this.al8();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.abm((ad) => ad.la = this.af7);
                    break;
                case "YAxisMinimumValue":
                    this.abn((ad) => ad.l5 = this.ahl, false);
                    break;
                case "YAxisMaximumValue":
                    this.abn((ad) => ad.l4 = this.ahk, false);
                    break;
                case "YAxisInterval":
                    this.abn((ad) => ad.l1 = this.ahj, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.amb();
                    break;
                case "ZoomSliderChart":
                    if (!this.aga) {
                        return;
                    }
                    this.ame(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.ak1((ad, ae) => {
                        if (ad.d6) {
                            ad.ms(this.add != null ? ArrayExtension.getModulus$1(Brush.$, this.add, ae) : null, this.ade != null ? ArrayExtension.getModulus$1(Brush.$, this.ade, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.ak0((ad, ae) => ad.o9 = this.adf != null ? ArrayExtension.getModulus$1(Brush.$, this.adf, ae) : null);
                    break;
                case "OverlayOutlines":
                    this.ak0((ad, ae) => ad.pe = this.adg != null ? ArrayExtension.getModulus$1(Brush.$, this.adg, ae) : null);
                    break;
                case "OverlayThickness":
                    this.ak0((ad, ae) => ad.g4 = this.ag9);
                    break;
                case "OverlayMultiplier":
                    this.ak0((ad, ae) => this.aex.setMultiplier(ad, this.ag8));
                    break;
                case "VolumeBrushes":
                    this.ak2((ad, ae) => ad.o9 = ArrayExtension.getModulus$1(Brush.$, this.adh, ae));
                    break;
                case "VolumeOutlines":
                    this.ak2((ad, ae) => ad.pe = ArrayExtension.getModulus$1(Brush.$, this.adi, ae));
                    break;
                case "VolumeThickness":
                    this.ak2((ad, ae) => ad.g4 = this.ahb);
                    break;
                case "IndicatorNegativeBrushes":
                    this.akz((ad, ae) => this.aes.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.adc, ae)));
                    break;
                case "IndicatorBrushes":
                    this.akz((ad, ae) => ad.o9 = ArrayExtension.getModulus$1(Brush.$, this.adb, ae));
                    break;
                case "IndicatorThickness":
                    this.akz((ad, ae) => ad.g4 = this.ag7);
                    break;
                case "IndicatorDisplayTypes":
                    this.akz((ad, ae) => this.aes.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aeu, ae)));
                    break;
                case "IndicatorPeriod":
                    this.akz((ad, ae) => {
                        if (this.ah2 == -2147483648) {
                            return;
                        }
                        this.aes.setPeriodOverride(ad, this.ah2);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.akz((ad, ae) => this.aes.setMultiplier(ad, this.ag6));
                    break;
                case "IndicatorSmoothingPeriod":
                    this.akz((ad, ae) => this.aes.setSmoothingPeriod(ad, this.ah5));
                    break;
                case "IndicatorShortPeriod":
                    this.akz((ad, ae) => this.aes.setShortPeriod(ad, this.ah3));
                    break;
                case "IndicatorLongPeriod":
                    this.akz((ad, ae) => this.aes.setLongPeriod(ad, this.ah1));
                    break;
                case "IndicatorSignalPeriod":
                    this.akz((ad, ae) => this.aes.setSignalPeriod(ad, this.ah4));
                    break;
                case "RangeSelectorOptions":
                    let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ala));
                    }
                    if (this.ad0 != null) {
                        let ae = this.ad0;
                        ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ala));
                    }
                    this.alw();
                    break;
                case "CustomIndicatorNames":
                    let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                    if (af != null) {
                        af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.ak6));
                    }
                    if (this.customIndicatorNames != null) {
                        let ag = this.customIndicatorNames;
                        ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.ak6));
                    }
                    this.al6();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.ak1((ah, ai) => ah.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, ai) : null, true);
                    break;
                case "Outlines":
                    this.ak1((ah, ai) => ah.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, ai) : null, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.ac1 == 0 && this.zoomSliderXAxis != null) {
                        this.abb(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                    }
                    this.akv();
                    break;
                case "YAxisLabelVisibility":
                    if (this.ac2 != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.abb(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jw = this.amh;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.er = this.ahn;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    let ah = this.afy && this.legend == null;
                    {
                        let ai = (aj, ak) => {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah ? this.aem : null;
                            }
                        };
                        this.ak1(ai, false);
                        this.ak0(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    let aj = typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.alt();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.fk) {
                            this.abf(this.zoomSliderAxis);
                        }
                        this.abb(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                    }
                    break;
                case "XAxisMinimumValue":
                    this.abh((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = this.ago;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.abh((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = this.agn;
                        }
                    });
                    break;
                case FinancialChart.aj2:
                    this.abi((ak) => ak.b1 = this.af6, a);
                    break;
                case FinancialChart.akd:
                    this.abm((ak) => ak.b1 = this.af8);
                    break;
            }
        }
        get_b1() {
            return 1;
        }
        get b1() {
            return this.get_b1();
        }
        get af9() {
            return this.afr;
        }
        set af9(a) {
            let b = this.af9;
            if (a != b) {
                this.afr = a;
                this.sy("YAxisIsLogarithmic", b, this.af9);
            }
        }
        get ah7() {
            return this.ahz;
        }
        set ah7(a) {
            let b = this.ah7;
            if (a != b) {
                this.ahz = a;
                this.sy("YAxisLogarithmBase", b, this.ah7);
            }
        }
        get ahj() {
            return this.ag0;
        }
        set ahj(a) {
            let b = this.ahj;
            if (a != b) {
                this.ag0 = a;
                this.sy("YAxisInterval", b, this.ahj);
            }
        }
        get ahl() {
            return this.ag2;
        }
        set ahl(a) {
            let b = this.ahl;
            if (a != b) {
                this.ag2 = a;
                this.sy("YAxisMinimumValue", b, this.ahl);
            }
        }
        get ahk() {
            return this.ag1;
        }
        set ahk(a) {
            let b = this.ahk;
            if (a != b) {
                this.ag1 = a;
                this.sy("YAxisMaximumValue", b, this.ahk);
            }
        }
        get ahm() {
            return this.ag3;
        }
        set ahm(a) {
            let b = this.ahm;
            if (a != b) {
                this.ag3 = a;
                this.sy("YAxisMinorInterval", b, this.ahm);
            }
        }
        get ahi() {
            return this.yAxis.lx;
        }
        get ahh() {
            return this.yAxis.lw;
        }
        get ad9() {
            return this.ad7;
        }
        set ad9(a) {
            let b = this.ad9;
            if (a != b) {
                this.ad7 = a;
                this.sy("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ad9));
            }
        }
        get aeb() {
            return this.aea;
        }
        set aeb(a) {
            let b = this.aeb;
            if (a != b) {
                this.aea = a;
                this.sy("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.aeb));
            }
        }
        get ahc() {
            return this.agv;
        }
        set ahc(a) {
            let b = this.ahc;
            if (a != b) {
                this.agv = a;
                this.sy("XAxisZoomMaximumCategoryRange", b, this.ahc);
            }
        }
        get ahf() {
            return this.agy;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.agy = a;
                this.sy("XAxisZoomToCategoryStart", b, this.ahf);
            }
        }
        get ahd() {
            return this.agw;
        }
        set ahd(a) {
            let b = this.ahd;
            if (a != b) {
                this.agw = a;
                this.sy("XAxisZoomMaximumItemSpan", b, this.ahd);
            }
        }
        get ahe() {
            return this.agx;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.agx = a;
                this.sy("XAxisZoomToCategoryRange", b, this.ahe);
            }
        }
        get ahg() {
            return this.agz;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.agz = a;
                this.sy("XAxisZoomToItemSpan", b, this.ahg);
            }
        }
        get aed() {
            return this.aec;
        }
        set aed(a) {
            let b = this.aed;
            if (a != b) {
                this.aec = a;
                this.sy("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.aed));
            }
        }
        get af2() {
            return this.afm;
        }
        set af2(a) {
            let b = this.af2;
            if (a != b) {
                this.afm = a;
                this.sy("IsToolbarVisible", b, this.af2);
            }
        }
        get ad4() {
            return this.ad3;
        }
        set ad4(a) {
            let b = this.ad4;
            if (a != b) {
                this.ad3 = a;
                this.sy("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ad4));
            }
        }
        get_abw() {
            return super.get_abw();
        }
        set_abw(a) {
            super.set_abw(a);
        }
        get af3() {
            return this.afn;
        }
        set af3(a) {
            let b = this.af3;
            if (a != b) {
                this.afn = a;
                this.sy("IsWindowSyncedToVisibleRange", b, this.af3);
            }
        }
        get aei() {
            return this.aeh;
        }
        set aei(a) {
            let b = this.aei;
            if (a != b) {
                this.aeh = a;
                this.sy("IndicatorTypes", b, this.aei);
            }
        }
        get aek() {
            return this.aej;
        }
        set aek(a) {
            let b = this.aek;
            if (a != b) {
                this.aej = a;
                this.sy("OverlayTypes", b, this.aek);
            }
        }
        get indicatorCharts() {
            return this.age;
        }
        set indicatorCharts(a) {
            let b = this.indicatorCharts;
            if (a != b) {
                this.age = a;
                this.sy("IndicatorCharts", b, this.indicatorCharts);
            }
        }
        get af7() {
            return this.afp;
        }
        set af7(a) {
            let b = this.af7;
            if (a != b) {
                this.afp = a;
                this.sy("YAxisAbbreviateLargeNumbers", b, this.af7);
            }
        }
        get_ix() {
            return super.get_ix();
        }
        set_ix(a) {
            super.set_ix(a);
        }
        get af6() {
            return this.afo;
        }
        set af6(a) {
            let b = this.af6;
            if (a != b) {
                this.afo = a;
                this.sy(FinancialChart.aj2, b, this.af6);
            }
        }
        get af8() {
            return this.afq;
        }
        set af8(a) {
            let b = this.af8;
            if (a != b) {
                this.afq = a;
                this.sy(FinancialChart.akd, b, this.af8);
            }
        }
        get zoomSliderChart() {
            return this.afg;
        }
        set zoomSliderChart(a) {
            let b = this.zoomSliderChart;
            if (a != b) {
                this.afg = a;
                this.sy("ZoomSliderChart", b, this.zoomSliderChart);
            }
        }
        get zoomSliderAxis() {
            return this.ae1;
        }
        set zoomSliderAxis(a) {
            let b = this.zoomSliderAxis;
            if (a != b) {
                this.ae1 = a;
                this.sy("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        }
        get zoomSliderXAxis() {
            return this.adm;
        }
        set zoomSliderXAxis(a) {
            let b = this.zoomSliderXAxis;
            if (a != b) {
                this.adm = a;
                this.sy("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        }
        get aeg() {
            return this.aee;
        }
        set aeg(a) {
            let b = this.aeg;
            if (a != b) {
                this.aee = a;
                this.sy("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aeg));
            }
        }
        get add() {
            return this.ac5;
        }
        set add(a) {
            let b = this.add;
            if (a != b) {
                this.ac5 = a;
                this.sy("NegativeBrushes", b, this.add);
            }
        }
        get ade() {
            return this.ac6;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.ac6 = a;
                this.sy("NegativeOutlines", b, this.ade);
            }
        }
        get adf() {
            return this.ac7;
        }
        set adf(a) {
            let b = this.adf;
            if (a != b) {
                this.ac7 = a;
                this.sy("OverlayBrushes", b, this.adf);
            }
        }
        get adg() {
            return this.ac8;
        }
        set adg(a) {
            let b = this.adg;
            if (a != b) {
                this.ac8 = a;
                this.sy("OverlayOutlines", b, this.adg);
            }
        }
        get adi() {
            return this.ada;
        }
        set adi(a) {
            let b = this.adi;
            if (a != b) {
                this.ada = a;
                this.sy("VolumeOutlines", b, this.adi);
            }
        }
        get adh() {
            return this.ac9;
        }
        set adh(a) {
            let b = this.adh;
            if (a != b) {
                this.ac9 = a;
                this.sy("VolumeBrushes", b, this.adh);
            }
        }
        get adc() {
            return this.ac4;
        }
        set adc(a) {
            let b = this.adc;
            if (a != b) {
                this.ac4 = a;
                this.sy("IndicatorNegativeBrushes", b, this.adc);
            }
        }
        get adb() {
            return this.ac3;
        }
        set adb(a) {
            let b = this.adb;
            if (a != b) {
                this.ac3 = a;
                this.sy("IndicatorBrushes", b, this.adb);
            }
        }
        get ahb() {
            return this.agu;
        }
        set ahb(a) {
            let b = this.ahb;
            if (a != b) {
                this.agu = a;
                this.sy("VolumeThickness", b, this.ahb);
            }
        }
        get ag9() {
            return this.ags;
        }
        set ag9(a) {
            let b = this.ag9;
            if (a != b) {
                this.ags = a;
                this.sy("OverlayThickness", b, this.ag9);
            }
        }
        get ag8() {
            return this.agr;
        }
        set ag8(a) {
            let b = this.ag8;
            if (a != b) {
                this.agr = a;
                this.sy("OverlayMultiplier", b, this.ag8);
            }
        }
        get ag7() {
            return this.agq;
        }
        set ag7(a) {
            let b = this.ag7;
            if (a != b) {
                this.agq = a;
                this.sy("IndicatorThickness", b, this.ag7);
            }
        }
        get aeu() {
            return this.aet;
        }
        set aeu(a) {
            let b = this.aeu;
            if (a != b) {
                this.aet = a;
                this.sy("IndicatorDisplayTypes", b, this.aeu);
            }
        }
        get ah2() {
            return this.ahv;
        }
        set ah2(a) {
            let b = this.ah2;
            if (a != b) {
                this.ahv = a;
                this.sy("IndicatorPeriod", b, this.ah2);
            }
        }
        get ag6() {
            return this.agp;
        }
        set ag6(a) {
            let b = this.ag6;
            if (a != b) {
                this.agp = a;
                this.sy("IndicatorMultiplier", b, this.ag6);
            }
        }
        get ah5() {
            return this.ahy;
        }
        set ah5(a) {
            let b = this.ah5;
            if (a != b) {
                this.ahy = a;
                this.sy("IndicatorSmoothingPeriod", b, this.ah5);
            }
        }
        get ah3() {
            return this.ahw;
        }
        set ah3(a) {
            let b = this.ah3;
            if (a != b) {
                this.ahw = a;
                this.sy("IndicatorShortPeriod", b, this.ah3);
            }
        }
        get ah1() {
            return this.ahu;
        }
        set ah1(a) {
            let b = this.ah1;
            if (a != b) {
                this.ahu = a;
                this.sy("IndicatorLongPeriod", b, this.ah1);
            }
        }
        get ah4() {
            return this.ahx;
        }
        set ah4(a) {
            let b = this.ah4;
            if (a != b) {
                this.ahx = a;
                this.sy("IndicatorSignalPeriod", b, this.ah4);
            }
        }
        get ad0() {
            return this.ady;
        }
        set ad0(a) {
            let b = this.ad0;
            if (a != b) {
                this.ady = a;
                this.sy("RangeSelectorOptions", b, this.ad0);
            }
        }
        get customIndicatorNames() {
            return this.adu;
        }
        set customIndicatorNames(a) {
            let b = this.adu;
            if (a != b) {
                this.adu = a;
                this.sy("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        }
        get_gb() {
            return super.get_gb();
        }
        set_gb(a) {
            super.set_gb(a);
        }
        get amh() {
            return this.amg;
        }
        set amh(a) {
            let b = this.amh;
            if (a != b) {
                this.amg = a;
                this.sy("ZoomSliderXAxisMajorStroke", b, this.amh);
            }
        }
        get ahn() {
            return this.ag4;
        }
        set ahn(a) {
            let b = this.ahn;
            if (a != b) {
                this.ag4 = a;
                this.sy("ZoomSliderXAxisMajorStrokeThickness", b, this.ahn);
            }
        }
        get afy() {
            return this.afl;
        }
        set afy(a) {
            let b = this.afy;
            if (a != b) {
                this.afl = a;
                this.sy("IsLegendVisible", b, this.afy);
            }
        }
        get aem() {
            return this.ael;
        }
        set aem(a) {
            let b = this.aem;
            if (a != b) {
                this.ael = a;
                this.sy("FinancialChartLegend", b, this.aem);
            }
        }
        get xAxis() {
            return this.adl;
        }
        set xAxis(a) {
            let b = this.xAxis;
            if (a != b) {
                this.adl = a;
                this.sy("XAxis", b, this.xAxis);
            }
        }
        get yAxis() {
            return this.ae0;
        }
        set yAxis(a) {
            let b = this.yAxis;
            if (a != b) {
                this.ae0 = a;
                this.sy("YAxis", b, this.yAxis);
            }
        }
        get volumeAxis() {
            return this.aez;
        }
        set volumeAxis(a) {
            let b = this.volumeAxis;
            if (a != b) {
                this.aez = a;
                this.sy("VolumeAxis", b, this.volumeAxis);
            }
        }
        get volumeXAxis() {
            return this.adk;
        }
        set volumeXAxis(a) {
            let b = this.volumeXAxis;
            if (a != b) {
                this.adk = a;
                this.sy("VolumeXAxis", b, this.volumeXAxis);
            }
        }
        get indicatorAxis() {
            return this.aey;
        }
        set indicatorAxis(a) {
            let b = this.indicatorAxis;
            if (a != b) {
                this.aey = a;
                this.sy("IndicatorAxis", b, this.indicatorAxis);
            }
        }
        get indicatorXAxis() {
            return this.adj;
        }
        set indicatorXAxis(a) {
            let b = this.indicatorXAxis;
            if (a != b) {
                this.adj = a;
                this.sy("IndicatorXAxis", b, this.indicatorXAxis);
            }
        }
        get agg() {
            return this.agd;
        }
        set agg(a) {
            let b = this.agg;
            if (a != b) {
                this.agd = a;
                this.sy("IndicatorAxes", b, this.agg);
            }
        }
        get agi() {
            return this.agf;
        }
        set agi(a) {
            let b = this.agi;
            if (a != b) {
                this.agf = a;
                this.sy("IndicatorXAxes", b, this.agi);
            }
        }
        get ago() {
            return this.agm;
        }
        set ago(a) {
            let b = this.ago;
            if (+a != +b) {
                this.agm = a;
                this.sy("XAxisMinimumValue", b, this.ago);
            }
        }
        get agn() {
            return this.agl;
        }
        set agn(a) {
            let b = this.agn;
            if (+a != +b) {
                this.agl = a;
                this.sy("XAxisMaximumValue", b, this.agn);
            }
        }
        get xAxisBreaks() {
            return this.agj;
        }
    }
    FinancialChart.$t = /*@__PURE__*/ markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ah6 = 0;
    FinancialChart.aj2 = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.akd = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
})();
/**
 * @hidden
 */
export let FinancialChartToolbar = /*@__PURE__*/ (() => {
    class FinancialChartToolbar extends TemplatedHtmlControl {
        bg(a) {
            let b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            let c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            let d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            let e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        }
        bl(a) {
            this.q.u(a);
            this.aa.u(a);
        }
        constructor(a, b) {
            super("financialChartToolbar", b, "");
            this.o = null;
            this.r = null;
            this.z = null;
            this.p = null;
            this.w = null;
            this.aq = dateMaxValue();
            this.ap = dateMinValue();
            this.ao = dateMaxValue();
            this.an = dateMinValue();
            this.rangeChanged = null;
            this.chartTypeChanged = null;
            this.trendLineTypeChanged = null;
            this.volumeTypeChanged = null;
            this.indicatorTypesChanged = null;
            this.overlayTypesChanged = null;
            this.x = 0;
            this.ah = 0;
            this.ab = 0;
            this.ad = null;
            this.af = null;
            this.t = null;
            this.ak = false;
            this.o = a;
            this.w = new FinancialChartToolbarViewModel();
            this.s = new FinancialChartRangeSelector(a != null ? a.aii : null);
            this.aa = new FinancialChartTypePicker(a != null ? a.aif : null);
            this.q = new FinancialChartIndicatorMenu(1, a != null ? a.aig : null);
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        }
        bm(a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    let d = b;
                    if (d != null) {
                        d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        let e = this.s;
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    let f = b;
                    if (f != null) {
                        f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        let g = this.aa;
                        g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    let h = typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        let i = this.q;
                        i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, EventArgs.empty);
                    }
                    break;
            }
        }
        bh(a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        }
        bi(a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        }
        bj(a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        }
        v() {
            let a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((() => {
                let $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((() => {
                let $ret = new FinancialChartTypePickerContext();
                $ret.vm = this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((() => {
                let $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = this.s.q;
                return $ret;
            })());
            return a;
        }
        l(a) {
            super.l(a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        }
        bk() {
        }
        get au() {
            return this.aq;
        }
        set au(a) {
            let b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        }
        get at() {
            return this.ap;
        }
        set at(a) {
            let b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        }
        get as() {
            return this.ao;
        }
        set as(a) {
            let b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        }
        get ar() {
            return this.an;
        }
        set ar(a) {
            let b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        }
        bn() {
            if (this.s != null) {
                this.s.ab();
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            let b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        }
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        }
        static am(a, b) {
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            for (let c of fromEn(a)) {
                if (!b.contains(c)) {
                    return false;
                }
            }
            return true;
        }
        aj() {
            return ((() => {
                let $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = this.s == null ? null : this.s.r();
                return $ret;
            })());
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        }
    }
    FinancialChartToolbar.$t = /*@__PURE__*/ markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
})();
/**
 * @hidden
 */
export let FinancialChartRangeSelector = /*@__PURE__*/ (() => {
    class FinancialChartRangeSelector extends TemplatedHtmlControl {
        get v() {
            return this.q.selectionStart;
        }
        set v(a) {
            this.q.selectionStart = a;
        }
        get u() {
            return this.q.selectionEnd;
        }
        set u(a) {
            this.q.selectionEnd = a;
        }
        get t() {
            return this.q.rangeStart;
        }
        set t(a) {
            this.q.rangeStart = a;
        }
        get s() {
            return this.q.rangeEnd;
        }
        set s(a) {
            this.q.rangeEnd = a;
        }
        ab() {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        }
        constructor(a) {
            super("financialChartRangeSelector", a, "");
            this.q = null;
            this.rangeChanged = null;
            this.p = null;
            this.p = new FinancialChartRangeSelectorView();
            this.q = new FinancialChartRangeSelectorViewModel();
            this.q.onRangeChanged = runOn(this, this.z);
            this.p.c = this.q;
        }
        l(a) {
            super.l(a);
            this.p.f(this.d, this.q);
        }
        z() {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, EventArgs.empty);
            }
        }
        r() {
            return this.p.d(this.g);
        }
        get o() {
            return this.q.options;
        }
        set o(a) {
            let b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        }
        aa() {
            if (this.q != null) {
                this.q.ao();
            }
            if (this.p != null) {
                this.p.i(this.o);
            }
        }
    }
    FinancialChartRangeSelector.$t = /*@__PURE__*/ markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
})();
