/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.v8 = null;
            this.v9 = null;
            this.wp = 0;
            this.wr = 5;
            this.wq = 0;
            this.wo = 5;
            this.w6 = 5;
            this.w8 = 0;
            this.w7 = 5;
            this.w5 = 0;
            this.abz = null;
            this.ab6 = null;
            this.abx = null;
            this.aby = null;
            this.w0 = 0;
            this.xh = 0;
            this.wz = NaN;
            this.xg = NaN;
            this.w2 = NaN;
            this.xj = NaN;
            this.w1 = NaN;
            this.xi = NaN;
            this.wy = NaN;
            this.xf = NaN;
            this.ab5 = null;
            this.acc = null;
            this.yr = null;
            this.yv = null;
            this.yt = null;
            this.yx = null;
            this.ym = null;
            this.yn = null;
            this.ab0 = null;
            this.ab7 = null;
            this.ws = DeviceUtils.g(1);
            this.w9 = DeviceUtils.g(1);
            this.wt = DeviceUtils.g(1);
            this.xa = DeviceUtils.g(1);
            this.ab2 = null;
            this.ab9 = null;
            this.ab3 = null;
            this.aca = null;
            this.wu = DeviceUtils.g(1);
            this.xb = DeviceUtils.g(1);
            this.wv = DeviceUtils.g(8);
            this.xc = 0;
            this.ab4 = null;
            this.acb = null;
            this.ww = DeviceUtils.g(1);
            this.xd = DeviceUtils.g(1);
            this.ys = null;
            this.yw = null;
            this.ab1 = null;
            this.ab8 = null;
            this.wn = 0;
            this.w4 = 0;
            this.wm = NaN;
            this.w3 = NaN;
            this.wx = 0;
            this.xe = -90;
            this.wi = false;
            this.wj = false;
            this.abs = 1;
            this.acv = 1;
            this.abr = 1;
            this.abt = 2;
            this.act = 0;
            this.acu = 1;
            this.acz = 0;
            this.ac0 = 0;
            this.wg = 4;
            this.we = 4;
            this.yq = null;
            this.v2 = null;
            this.yu = null;
            this.v3 = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.v6();
                let c = this.v7();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        sb() {
            super.sb();
            let a = this.v6();
            let b = this.v7();
            if (a != null && a.az != null) {
                this.acf = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.acm = b.az.textColor;
            }
            this.ack = AxisDefaults.j;
            this.acr = AxisDefaults.j;
            this.acg = AxisDefaults.h;
            this.acn = AxisDefaults.h;
            this.acj = AxisDefaults.g;
            this.acq = AxisDefaults.g;
        }
        s1(a, b, c) {
            super.s1(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.abj((d) => d.leftMargin = this.xr);
                    break;
                case "XAxisLabelTopMargin":
                    this.abj((d) => d.topMargin = this.xt);
                    break;
                case "XAxisLabelRightMargin":
                    this.abj((d) => d.rightMargin = this.xs);
                    break;
                case "XAxisLabelBottomMargin":
                    this.abj((d) => d.bottomMargin = this.xq);
                    break;
                case "YAxisLabelLeftMargin":
                    this.abo((d) => d.leftMargin = this.x8);
                    break;
                case "YAxisLabelTopMargin":
                    this.abo((d) => d.topMargin = this.ya);
                    break;
                case "YAxisLabelRightMargin":
                    this.abo((d) => d.rightMargin = this.x9);
                    break;
                case "YAxisLabelBottomMargin":
                    this.abo((d) => d.bottomMargin = this.x7);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.acd = this.u9(this.acf);
                    this.ace = this.u9(this.acm);
                    break;
                case "XAxisLabelTextColor":
                    this.acd = this.u9(this.acf);
                    break;
                case "YAxisLabelTextColor":
                    this.ace = this.u9(this.acm);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.abj((d) => d.textColor = this.acd);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.abo((d) => d.textColor = this.ace);
                    break;
                case "XAxisTitleMargin":
                    this.abl((d) => d.margin = this.x2);
                    break;
                case "YAxisTitleMargin":
                    this.abq((d) => d.margin = this.yj);
                    break;
                case "XAxisTitleLeftMargin":
                    this.abl((d) => d.leftMargin = this.x1);
                    break;
                case "YAxisTitleLeftMargin":
                    this.abq((d) => d.leftMargin = this.yi);
                    break;
                case "XAxisTitleTopMargin":
                    this.abl((d) => d.topMargin = this.x4);
                    break;
                case "YAxisTitleTopMargin":
                    this.abq((d) => d.topMargin = this.yl);
                    break;
                case "XAxisTitleRightMargin":
                    this.abl((d) => d.rightMargin = this.x3);
                    break;
                case "YAxisTitleRightMargin":
                    this.abq((d) => d.rightMargin = this.yk);
                    break;
                case "XAxisTitleBottomMargin":
                    this.abl((d) => d.bottomMargin = this.x0);
                    break;
                case "YAxisTitleBottomMargin":
                    this.abq((d) => d.bottomMargin = this.yh);
                    break;
                case "XAxisTitleTextColor":
                    this.abl((d) => d.textColor = this.acl);
                    break;
                case "YAxisTitleTextColor":
                    this.abq((d) => d.textColor = this.acs);
                    break;
                case "XAxisFormatLabel":
                    this.abh((d) => d.au = this.wa);
                    break;
                case "YAxisFormatLabel":
                    this.abm((d) => d.au = this.wb);
                    break;
            }
        }
        get wa() {
            return this.v8;
        }
        set wa(a) {
            let b = this.wa;
            if (a != b) {
                this.v8 = a;
                this.sy("XAxisFormatLabel", b, this.wa);
            }
        }
        get wb() {
            return this.v9;
        }
        set wb(a) {
            let b = this.wb;
            if (a != b) {
                this.v9 = a;
                this.sy("YAxisFormatLabel", b, this.wb);
            }
        }
        get xr() {
            return this.wp;
        }
        set xr(a) {
            let b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sy("XAxisLabelLeftMargin", b, this.xr);
            }
        }
        get xt() {
            return this.wr;
        }
        set xt(a) {
            let b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sy("XAxisLabelTopMargin", b, this.xt);
            }
        }
        get xs() {
            return this.wq;
        }
        set xs(a) {
            let b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sy("XAxisLabelRightMargin", b, this.xs);
            }
        }
        get xq() {
            return this.wo;
        }
        set xq(a) {
            let b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sy("XAxisLabelBottomMargin", b, this.xq);
            }
        }
        get x8() {
            return this.w6;
        }
        set x8(a) {
            let b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.sy("YAxisLabelLeftMargin", b, this.x8);
            }
        }
        get ya() {
            return this.w8;
        }
        set ya(a) {
            let b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.sy("YAxisLabelTopMargin", b, this.ya);
            }
        }
        get x9() {
            return this.w7;
        }
        set x9(a) {
            let b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.sy("YAxisLabelRightMargin", b, this.x9);
            }
        }
        get x7() {
            return this.w5;
        }
        set x7(a) {
            let b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.sy("YAxisLabelBottomMargin", b, this.x7);
            }
        }
        get acf() {
            return this.abz;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abz = a;
                this.sy("XAxisLabelTextColor", b, this.acf);
            }
        }
        get acm() {
            return this.ab6;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.ab6 = a;
                this.sy("YAxisLabelTextColor", b, this.acm);
            }
        }
        get acd() {
            return this.abx;
        }
        set acd(a) {
            let b = this.abx;
            if (a != b) {
                this.abx = a;
                this.sy("ActualXAxisLabelTextColor", b, this.acd);
            }
        }
        get ace() {
            return this.aby;
        }
        set ace(a) {
            let b = this.aby;
            if (a != b) {
                this.aby = a;
                this.sy("ActualYAxisLabelTextColor", b, this.ace);
            }
        }
        get x2() {
            return this.w0;
        }
        set x2(a) {
            let b = this.x2;
            if (a != b) {
                this.w0 = a;
                this.sy("XAxisTitleMargin", b, this.x2);
            }
        }
        get yj() {
            return this.xh;
        }
        set yj(a) {
            let b = this.yj;
            if (a != b) {
                this.xh = a;
                this.sy("YAxisTitleMargin", b, this.yj);
            }
        }
        get x1() {
            return this.wz;
        }
        set x1(a) {
            let b = this.x1;
            if (a != b) {
                this.wz = a;
                this.sy("XAxisTitleLeftMargin", b, this.x1);
            }
        }
        get yi() {
            return this.xg;
        }
        set yi(a) {
            let b = this.yi;
            if (a != b) {
                this.xg = a;
                this.sy("YAxisTitleLeftMargin", b, this.yi);
            }
        }
        get x4() {
            return this.w2;
        }
        set x4(a) {
            let b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.sy("XAxisTitleTopMargin", b, this.x4);
            }
        }
        get yl() {
            return this.xj;
        }
        set yl(a) {
            let b = this.yl;
            if (a != b) {
                this.xj = a;
                this.sy("YAxisTitleTopMargin", b, this.yl);
            }
        }
        get x3() {
            return this.w1;
        }
        set x3(a) {
            let b = this.x3;
            if (a != b) {
                this.w1 = a;
                this.sy("XAxisTitleRightMargin", b, this.x3);
            }
        }
        get yk() {
            return this.xi;
        }
        set yk(a) {
            let b = this.yk;
            if (a != b) {
                this.xi = a;
                this.sy("YAxisTitleRightMargin", b, this.yk);
            }
        }
        get x0() {
            return this.wy;
        }
        set x0(a) {
            let b = this.x0;
            if (a != b) {
                this.wy = a;
                this.sy("XAxisTitleBottomMargin", b, this.x0);
            }
        }
        get yh() {
            return this.xf;
        }
        set yh(a) {
            let b = this.yh;
            if (a != b) {
                this.xf = a;
                this.sy("YAxisTitleBottomMargin", b, this.yh);
            }
        }
        get acl() {
            return this.ab5;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.ab5 = a;
                this.sy("XAxisTitleTextColor", b, this.acl);
            }
        }
        get acs() {
            return this.acc;
        }
        set acs(a) {
            let b = this.acs;
            if (a != b) {
                this.acc = a;
                this.sy("YAxisTitleTextColor", b, this.acs);
            }
        }
        s2(a, b, c) {
            super.s2(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.abj((d) => d.textStyle = this.zf);
                    break;
                case "YAxisLabelTextStyle":
                    this.abo((d) => d.textStyle = this.aak);
                    break;
                case "XAxisTitleTextStyle":
                    this.abl((d) => d.textStyle = this.z3);
                    break;
                case "YAxisTitleTextStyle":
                    this.abq((d) => d.textStyle = this.aa8);
                    break;
            }
        }
        get zf() {
            return this.yr;
        }
        set zf(a) {
            let b = this.zf;
            if (a != b) {
                this.yr = a;
                this.sy("XAxisLabelTextStyle", b, this.zf);
            }
        }
        get aak() {
            return this.yv;
        }
        set aak(a) {
            let b = this.aak;
            if (a != b) {
                this.yv = a;
                this.sy("YAxisLabelTextStyle", b, this.aak);
            }
        }
        get z3() {
            return this.yt;
        }
        set z3(a) {
            let b = this.z3;
            if (a != b) {
                this.yt = a;
                this.sy("XAxisTitleTextStyle", b, this.z3);
            }
        }
        get aa8() {
            return this.yx;
        }
        set aa8(a) {
            let b = this.aa8;
            if (a != b) {
                this.yx = a;
                this.sy("YAxisTitleTextStyle", b, this.aa8);
            }
        }
        abe(a) {
            this.abb(a, (b) => b.leftMargin = this.xr);
            this.abb(a, (b) => b.topMargin = this.xt);
            this.abb(a, (b) => b.rightMargin = this.xs);
            this.abb(a, (b) => b.bottomMargin = this.xq);
            this.abb(a, (b) => b.textColor = this.acd);
            this.abc(a, (b) => b.textColor = this.acl);
            this.abc(a, (b) => b.leftMargin = this.x1);
            this.abc(a, (b) => b.topMargin = this.x4);
            this.abc(a, (b) => b.rightMargin = this.x3);
            this.abc(a, (b) => b.bottomMargin = this.x0);
            this.abb(a, (b) => b.textStyle = this.zf);
            this.abc(a, (b) => b.textStyle = this.z3);
        }
        abg(a) {
            this.abb(a, (b) => b.leftMargin = this.x8);
            this.abb(a, (b) => b.topMargin = this.ya);
            this.abb(a, (b) => b.rightMargin = this.x9);
            this.abb(a, (b) => b.bottomMargin = this.x7);
            this.abb(a, (b) => b.textColor = this.ace);
            this.abc(a, (b) => b.textColor = this.acs);
            this.abc(a, (b) => b.leftMargin = this.yi);
            this.abc(a, (b) => b.topMargin = this.yl);
            this.abc(a, (b) => b.rightMargin = this.yk);
            this.abc(a, (b) => b.bottomMargin = this.yh);
            this.abb(a, (b) => b.textStyle = this.aak);
            this.abc(a, (b) => b.textStyle = this.aa8);
        }
        tj(a) {
            let b = this.bc(a);
            let c = this.c1(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.og(a);
            c.title = this.oh(a, b);
            this.dataChart.series.add(c);
        }
        abh(a) {
            this.abi(a, null);
        }
        abi(a, b) {
            a(this.v6());
        }
        abn(a, b) {
            a(this.v7());
        }
        abm(a) {
            this.abn(a, true);
        }
        rv(a, b) {
            this.abh(a);
            this.abn(a, b);
        }
        abl(a) {
            this.abc(this.v6(), a);
        }
        abq(a) {
            this.abc(this.v7(), a);
        }
        abo(a) {
            this.abb(this.v7(), a);
        }
        abj(a) {
            this.abb(this.v6(), a);
        }
        xk(a) {
            let b = this.v6();
            return b.ej(a, new ScalerParams(1, this.vh, this.vg, b.ch));
        }
        xm(a) {
            let b = this.v6();
            return b.em(a, new ScalerParams(1, this.vh, this.vg, b.ch));
        }
        xl(a) {
            let b = this.v7();
            return b.ej(a, new ScalerParams(1, this.vh, this.vg, b.ch));
        }
        xn(a) {
            let b = this.v7();
            return b.em(a, new ScalerParams(1, this.vh, this.vg, b.ch));
        }
        tg(a) {
            super.tg(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.v6();
                let c = this.v7();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static y0(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        r6(a) {
            super.r6(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.v6());
                this.dataChart.axes.add(this.v7());
            }
        }
        abd(a) {
            if (a != null && this.ka != null && a.fl == null) {
                a.provideRenderer(this.ka);
            }
            a.jw = this.acg;
            a.er = this.xu;
            a.jx = this.ach;
            a.eu = this.xv;
            a.jz = this.acj;
            a.fg = this.xw;
            a.jy = this.aci;
            a.fh = this.xx;
            a.j0 = this.ack;
            a.fi = this.xy;
            a.c4 = true;
            a.cu = this.gd;
            a.cw = this.gd;
            let b = a == this.v6();
            if (b) {
                a.g6 = this.zu;
            }
            a.f0 = this.yo;
            a.gg = this.y6;
            a.ah = this.v4;
            this.abb(a, (c) => c.angle = this.xp);
            this.abb(a, (c) => {
                if (c.extent != this.xo) {
                    c.extent = this.xo;
                }
            });
            this.abb(a, (c) => c.horizontalAlignment = this.abu);
            this.abb(a, (c) => c.verticalAlignment = this.acw);
            this.abb(a, (c) => c.visibility = this.ac1);
            this.abb(a, (c) => c.location = this.wc(this.wf));
            this.abc(a, (c) => c.horizontalAlignment = this.abv);
            this.abc(a, (c) => c.angle = this.xz);
            this.abe(a);
        }
        abf(a) {
            if (a == null) {
                return;
            }
            if (this.ka != null && a.fl == null) {
                a.provideRenderer(this.ka);
            }
            a.cu = this.gd;
            a.cw = this.gd;
            this.abb(a, (b) => b.angle = this.x6);
            this.abb(a, (b) => {
                if (b.extent != this.x5) {
                    b.extent = this.x5;
                }
            });
            this.abb(a, (b) => b.horizontalAlignment = this.abw);
            this.abb(a, (b) => b.verticalAlignment = this.acx);
            this.abb(a, (b) => b.visibility = this.ac2);
            this.abb(a, (b) => b.location = this.wd(this.wh));
            this.abc(a, (b) => b.verticalAlignment = this.acy);
            this.abc(a, (b) => b.angle = this.yg);
            a.jw = this.acn;
            a.er = this.yb;
            a.jx = this.aco;
            a.eu = this.yc;
            a.jz = this.acq;
            a.fg = this.yd;
            a.jy = this.acp;
            a.fh = this.ye;
            a.j0 = this.acr;
            a.fi = this.yf;
            let b = a == this.v7();
            if (b) {
                a.g6 = this.aaz;
            }
            a.gg = this.aab;
            a.ah = this.v5;
            this.abg(a);
        }
        r3() {
            super.r3();
            this.abd(this.v6());
            this.abf(this.v7());
        }
        abb(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d5();
                a.az.bottomMargin = a.d6();
                a.az.leftMargin = a.d7();
                a.az.rightMargin = a.d8();
                a.az.topMargin = a.d9();
                a.az.horizontalAlignment = a.jr();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.kk();
            }
            b(a.az);
        }
        abc(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.eb();
                a.bf.leftMargin = a.ec();
                a.bf.rightMargin = a.ed();
                a.bf.topMargin = a.ee();
                a.bf.location = a.a1();
                a.bf.angle = a.ea();
                a.bf.horizontalAlignment = a.js();
                a.bf.verticalAlignment = a.kl();
            }
            b(a.bf);
        }
        sy(a, b, c) {
            super.sy(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.abj((d) => d.angle = this.xp);
                    break;
                case "YAxisLabelAngle":
                    this.abo((d) => d.angle = this.x6);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.abj((d) => d.horizontalAlignment = this.abu);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.abo((d) => d.horizontalAlignment = this.abw);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.abj((d) => d.verticalAlignment = this.acw);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.abo((d) => d.verticalAlignment = this.acx);
                    break;
                case "XAxisLabelVisibility":
                    this.abj((d) => d.visibility = this.ac1);
                    break;
                case "YAxisLabelVisibility":
                    this.abo((d) => d.visibility = this.ac2);
                    break;
                case "XAxisLabel":
                    this.abh((d) => d.f0 = this.yo);
                    break;
                case "YAxisLabel":
                    this.abm((d) => d.f0 = this.yp);
                    break;
                case "XAxisLabelFormat":
                    this.abh((d) => d.gg = this.y6);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.abh((d) => d.ah = this.v4);
                    break;
                case "YAxisLabelFormat":
                    this.abm((d) => d.gg = this.aab);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.abm((d) => d.ah = this.v5);
                    break;
                case "XAxisTitleAngle":
                    this.abl((d) => d.angle = this.xz);
                    break;
                case "YAxisTitleAngle":
                    this.abq((d) => d.angle = this.yg);
                    break;
                case "XAxisTitleAlignment":
                    this.abl((d) => d.horizontalAlignment = this.abv);
                    break;
                case "YAxisTitleAlignment":
                    this.abq((d) => d.verticalAlignment = this.acy);
                    break;
                case "XAxisTitle":
                    this.abh((d) => d.g6 = this.zu);
                    break;
                case "YAxisTitle":
                    this.abn((d) => d.g6 = this.aaz, false);
                    break;
                case "XAxisMajorStroke":
                    this.abi((d) => d.jw = this.acg, a);
                    break;
                case "YAxisMajorStroke":
                    this.abm((d) => d.jw = this.acn);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.abi((d) => d.er = this.xu, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.abm((d) => d.er = this.yb);
                    break;
                case "XAxisMinorStroke":
                    this.abh((d) => d.jx = this.ach);
                    break;
                case "YAxisMinorStroke":
                    this.abm((d) => d.jx = this.aco);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.abh((d) => d.eu = this.xv);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.abm((d) => d.eu = this.yc);
                    break;
                case "XAxisTickLength":
                    this.abh((d) => d.fh = this.xx);
                    break;
                case "YAxisTickLength":
                    this.abm((d) => d.fh = this.ye);
                    break;
                case "XAxisTickStroke":
                    this.abh((d) => d.j0 = this.ack);
                    break;
                case "YAxisTickStroke":
                    this.abm((d) => d.j0 = this.acr);
                    break;
                case "XAxisTickStrokeThickness":
                    this.abh((d) => d.fi = this.xy);
                    break;
                case "YAxisTickStrokeThickness":
                    this.abm((d) => d.fi = this.yf);
                    break;
                case "XAxisStroke":
                    this.abh((d) => d.jz = this.acj);
                    break;
                case "YAxisStroke":
                    this.abm((d) => d.jz = this.acq);
                    break;
                case "XAxisStrokeThickness":
                    this.abh((d) => d.fg = this.xw);
                    break;
                case "YAxisStrokeThickness":
                    this.abm((d) => d.fg = this.yd);
                    break;
                case "XAxisExtent":
                    this.abj((d) => d.extent = this.xo);
                    break;
                case "YAxisExtent":
                    this.abo((d) => d.extent = this.x5);
                    break;
                case "XAxisStrip":
                    this.abh((d) => d.jy = this.aci);
                    break;
                case "YAxisStrip":
                    this.abm((d) => d.jy = this.acp);
                    break;
                case "XAxisInverted":
                    this.abh((d) => d.ch = this.wk);
                    break;
                case "YAxisInverted":
                    this.abm((d) => d.ch = this.wl);
                    break;
                case "YAxisLabelLocation":
                    this.abp();
                    break;
                case "XAxisLabelLocation":
                    this.abk();
                    break;
            }
        }
        abp() {
            let a = this.wd(this.wh);
            if (a == 2 || a == 7) {
                this.abw = 2;
            }
            else {
                this.abw = 0;
            }
            this.abo((b) => b.location = a);
        }
        abk() {
            let a = this.wc(this.wf);
            if (a == 1 || a == 5) {
                this.acw = 0;
            }
            else {
                this.acw = 2;
            }
            this.abj((b) => b.location = a);
        }
        wd(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.b1 == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        wc(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get yo() {
            return this.ym;
        }
        set yo(a) {
            let b = this.yo;
            if (a != b) {
                this.ym = a;
                this.sy("XAxisLabel", b, this.yo);
            }
        }
        get yp() {
            return this.yn;
        }
        set yp(a) {
            let b = this.yp;
            if (a != b) {
                this.yn = a;
                this.sy("YAxisLabel", b, this.yp);
            }
        }
        get acg() {
            return this.ab0;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.ab0 = a;
                this.sy("XAxisMajorStroke", b, this.acg);
            }
        }
        get acn() {
            return this.ab7;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.ab7 = a;
                this.sy("YAxisMajorStroke", b, this.acn);
            }
        }
        get xu() {
            return this.ws;
        }
        set xu(a) {
            let b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sy("XAxisMajorStrokeThickness", b, this.xu);
            }
        }
        get yb() {
            return this.w9;
        }
        set yb(a) {
            let b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.sy("YAxisMajorStrokeThickness", b, this.yb);
            }
        }
        get xv() {
            return this.wt;
        }
        set xv(a) {
            let b = this.xv;
            if (a != b) {
                this.wt = a;
                this.sy("XAxisMinorStrokeThickness", b, this.xv);
            }
        }
        get yc() {
            return this.xa;
        }
        set yc(a) {
            let b = this.yc;
            if (a != b) {
                this.xa = a;
                this.sy("YAxisMinorStrokeThickness", b, this.yc);
            }
        }
        get aci() {
            return this.ab2;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.ab2 = a;
                this.sy("XAxisStrip", b, this.aci);
            }
        }
        get acp() {
            return this.ab9;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.ab9 = a;
                this.sy("YAxisStrip", b, this.acp);
            }
        }
        get acj() {
            return this.ab3;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.ab3 = a;
                this.sy("XAxisStroke", b, this.acj);
            }
        }
        get acq() {
            return this.aca;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.aca = a;
                this.sy("YAxisStroke", b, this.acq);
            }
        }
        get xw() {
            return this.wu;
        }
        set xw(a) {
            let b = this.xw;
            if (a != b) {
                this.wu = a;
                this.sy("XAxisStrokeThickness", b, this.xw);
            }
        }
        get yd() {
            return this.xb;
        }
        set yd(a) {
            let b = this.yd;
            if (a != b) {
                this.xb = a;
                this.sy("YAxisStrokeThickness", b, this.yd);
            }
        }
        get xx() {
            return this.wv;
        }
        set xx(a) {
            let b = this.xx;
            if (a != b) {
                this.wv = a;
                this.sy("XAxisTickLength", b, this.xx);
            }
        }
        get ye() {
            return this.xc;
        }
        set ye(a) {
            let b = this.ye;
            if (a != b) {
                this.xc = a;
                this.sy("YAxisTickLength", b, this.ye);
            }
        }
        get ack() {
            return this.ab4;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.ab4 = a;
                this.sy("XAxisTickStroke", b, this.ack);
            }
        }
        get acr() {
            return this.acb;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.acb = a;
                this.sy("YAxisTickStroke", b, this.acr);
            }
        }
        get xy() {
            return this.ww;
        }
        set xy(a) {
            let b = this.xy;
            if (a != b) {
                this.ww = a;
                this.sy("XAxisTickStrokeThickness", b, this.xy);
            }
        }
        get yf() {
            return this.xd;
        }
        set yf(a) {
            let b = this.yf;
            if (a != b) {
                this.xd = a;
                this.sy("YAxisTickStrokeThickness", b, this.yf);
            }
        }
        get zu() {
            return this.ys;
        }
        set zu(a) {
            let b = this.zu;
            if (a != b) {
                this.ys = a;
                this.sy("XAxisTitle", b, this.zu);
            }
        }
        get aaz() {
            return this.yw;
        }
        set aaz(a) {
            let b = this.aaz;
            if (a != b) {
                this.yw = a;
                this.sy("YAxisTitle", b, this.aaz);
            }
        }
        get ach() {
            return this.ab1;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.ab1 = a;
                this.sy("XAxisMinorStroke", b, this.ach);
            }
        }
        get aco() {
            return this.ab8;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.ab8 = a;
                this.sy("YAxisMinorStroke", b, this.aco);
            }
        }
        get xp() {
            return this.wn;
        }
        set xp(a) {
            let b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sy("XAxisLabelAngle", b, this.xp);
            }
        }
        get x6() {
            return this.w4;
        }
        set x6(a) {
            let b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.sy("YAxisLabelAngle", b, this.x6);
            }
        }
        get xo() {
            return this.wm;
        }
        set xo(a) {
            let b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sy("XAxisExtent", b, this.xo);
            }
        }
        get x5() {
            return this.w3;
        }
        set x5(a) {
            let b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.sy("YAxisExtent", b, this.x5);
            }
        }
        get xz() {
            return this.wx;
        }
        set xz(a) {
            let b = this.xz;
            if (a != b) {
                this.wx = a;
                this.sy("XAxisTitleAngle", b, this.xz);
            }
        }
        get yg() {
            return this.xe;
        }
        set yg(a) {
            let b = this.yg;
            if (a != b) {
                this.xe = a;
                this.sy("YAxisTitleAngle", b, this.yg);
            }
        }
        get wk() {
            return this.wi;
        }
        set wk(a) {
            let b = this.wk;
            if (a != b) {
                this.wi = a;
                this.sy("XAxisInverted", b, this.wk);
            }
        }
        get wl() {
            return this.wj;
        }
        set wl(a) {
            let b = this.wl;
            if (a != b) {
                this.wj = a;
                this.sy("YAxisInverted", b, this.wl);
            }
        }
        get abv() {
            return this.abs;
        }
        set abv(a) {
            let b = this.abv;
            if (a != b) {
                this.abs = a;
                this.sy("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abv));
            }
        }
        get acy() {
            return this.acv;
        }
        set acy(a) {
            let b = this.acy;
            if (a != b) {
                this.acv = a;
                this.sy("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acy));
            }
        }
        get abu() {
            return this.abr;
        }
        set abu(a) {
            let b = this.abu;
            if (a != b) {
                this.abr = a;
                this.sy("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abu));
            }
        }
        get_abw() {
            return this.abt;
        }
        set_abw(a) {
            let b = this.abw;
            if (a != b) {
                this.abt = a;
                this.sy("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abw));
            }
        }
        get abw() {
            return this.get_abw();
        }
        set abw(a) {
            this.set_abw(a);
        }
        get acw() {
            return this.act;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.act = a;
                this.sy("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acw));
            }
        }
        get acx() {
            return this.acu;
        }
        set acx(a) {
            let b = this.acx;
            if (a != b) {
                this.acu = a;
                this.sy("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acx));
            }
        }
        get ac1() {
            return this.acz;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.acz = a;
                this.sy("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ac1));
            }
        }
        get ac2() {
            return this.ac0;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.ac0 = a;
                this.sy("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ac2));
            }
        }
        get_wh() {
            return this.wg;
        }
        set_wh(a) {
            let b = this.wh;
            if (a != b) {
                this.wg = a;
                this.sy("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wh));
            }
        }
        get wh() {
            return this.get_wh();
        }
        set wh(a) {
            this.set_wh(a);
        }
        get_wf() {
            return this.we;
        }
        set_wf(a) {
            let b = this.wf;
            if (a != b) {
                this.we = a;
                this.sy("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.wf));
            }
        }
        get wf() {
            return this.get_wf();
        }
        set wf(a) {
            this.set_wf(a);
        }
        get y6() {
            return this.yq;
        }
        set y6(a) {
            let b = this.yq;
            if (a != b) {
                this.yq = a;
                this.sy("XAxisLabelFormat", b, this.yq);
            }
        }
        get v4() {
            return this.v2;
        }
        set v4(a) {
            let b = this.v2;
            if (a != b) {
                this.v2 = a;
                this.sy("XAxisLabelFormatSpecifiers", b, this.v2);
            }
        }
        get aab() {
            return this.yu;
        }
        set aab(a) {
            let b = this.yu;
            if (a != b) {
                this.yu = a;
                this.sy("YAxisLabelFormat", b, this.yu);
            }
        }
        get v5() {
            return this.v3;
        }
        set v5(a) {
            let b = this.v3;
            if (a != b) {
                this.v3 = a;
                this.sy("YAxisLabelFormatSpecifiers", b, this.v3);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
