/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.aev = null;
        _this.aht = null;
        _this.ahr = null;
        _this.aho = null;
        _this.ahq = null;
        _this.ahs = null;
        _this.ahp = null;
        _this.ad1 = null;
        _this.aib = null;
        _this.aic = null;
        _this.ah8 = null;
        _this.aid = null;
        _this.aie = null;
        _this.ah9 = null;
        _this.aia = null;
        _this.afj = null;
        _this.agt = 40;
        _this.aep = null;
        _this.aen = null;
        _this.aer = null;
        _this.aew = null;
        _this.aim = null;
        _this.aff = null;
        _this.af5 = false;
        _this.af4 = false;
        _this.agc = false;
        _this.afr = false;
        _this.ahz = 10;
        _this.ag0 = NaN;
        _this.ag2 = NaN;
        _this.ag1 = NaN;
        _this.ag3 = 0;
        _this.ad7 = 0;
        _this.aea = 0;
        _this.agv = 3;
        _this.agy = NaN;
        _this.agw = NaN;
        _this.agx = NaN;
        _this.agz = NaN;
        _this.aec = 0;
        _this.afm = true;
        _this.ad3 = 0;
        _this.afn = false;
        _this.aeh = null;
        _this.aej = null;
        _this.age = null;
        _this.afp = true;
        _this.afo = false;
        _this.afq = false;
        _this.afg = null;
        _this.aee = 1;
        _this.ac5 = null;
        _this.ac6 = null;
        _this.ac7 = null;
        _this.ac8 = null;
        _this.ada = null;
        _this.ac9 = null;
        _this.ac4 = null;
        _this.ac3 = null;
        _this.agu = 1;
        _this.ags = 1;
        _this.agr = 2;
        _this.agq = 1;
        _this.aet = null;
        _this.ahv = -2147483648;
        _this.agp = 2;
        _this.ahy = 3;
        _this.ahw = 10;
        _this.ahu = 30;
        _this.ahx = 9;
        _this.ady = null;
        _this.adz = null;
        _this.adu = null;
        _this.applyCustomIndicators = null;
        _this.amg = null;
        _this.ag4 = 1;
        _this.afl = false;
        _this.ael = null;
        _this.agm = dateMinValue();
        _this.agl = dateMaxValue();
        _this.agj = null;
        _this.rt();
        _this.agj = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.al5(); });
        }
        _this.alq();
        return _this;
    }
    FinancialChart.prototype.s2 = function (a, b, c) {
        _super.prototype.s2.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.ad2 = new FinancialChartToolbar(this, this.aij);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ald));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.alg));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.alh));
                    d.l(null);
                }
                if (this.ad2 != null) {
                    this.ad2.ac = this.ad9;
                    this.ad2.ai = this.dq;
                    this.ad2.y = this.ad4;
                    this.ad2.al = this.af2;
                    if (this.ahq != null) {
                        this.ad2.l(this.ahq);
                    }
                    var e = this.ad2;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ald));
                    ;
                    var f = this.ad2;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.alg));
                    var g = this.ad2;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.alh));
                }
                break;
            case "ChartType":
                if (this.ad2 != null) {
                    this.ad2.y = this.ad4;
                }
                break;
            case "VolumeType":
                if (this.ad2 != null) {
                    this.ad2.ac = this.ad9;
                }
                break;
            case "TrendLineType":
                if (this.ad2 != null) {
                    this.ad2.ai = this.dq;
                }
                break;
            case "IsToolbarVisible":
                if (this.ad2 == null) {
                    break;
                }
                this.ad2.al = this.af2;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.alh = function (a, b) {
        this.ad9 = this.ad2.ac;
    };
    FinancialChart.prototype.alg = function (a, b) {
        this.dq = this.ad2.ai;
    };
    FinancialChart.prototype.ald = function (a, b) {
        this.ad4 = this.ad2.y;
    };
    FinancialChart.prototype.alq = function () {
        this.aev = new IndicatorPane();
        this.aem = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.aht = a;
        this.amb();
        this.setGridRows();
        if (this.ad2 != null) {
            this.ad2.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.ad2 != null) {
            this.ad2.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.ad2.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.ka;
        b.toolbarContainer = this.ahq;
        b.legendContainer = this.ahp;
        b.indicatorsContainer = this.aho;
        b.volumeContainer = this.ahr;
        b.zoomContainer = this.ahs;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.ad2 == null) {
                this.ad2 = new FinancialChartToolbar(this, this.aij);
            }
            this.ad2.w.isIndicatorMenuVisible = this.aft && this.afu;
            this.ahq = b.getSubRenderer(d);
            this.ad2.l(this.ahq);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.ahp = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.aho = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.ahr = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ahs = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.ahq = null;
            if (this.ad2 != null) {
                this.ad2.l(null);
            }
            if (this.afk != null) {
                this.afk.provideContainer(null);
                this.afk = null;
            }
            if (this.aem != null) {
                this.aem.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.ahr);
            }
            if (this.aev != null) {
                this.aev.h(this.aho);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ahs);
                if (a != null) {
                    this.akx();
                }
                else {
                    this.afk = null;
                }
            }
            if (this.aem != null) {
                this.aem.provideContainer(this.ahp);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.al1 = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.amf = function (a, b) {
        this.al1(a, b, this.ahs);
        if (b == null) {
            return;
        }
        this.akx();
    };
    FinancialChart.prototype.akx = function () {
        var _this = this;
        if (this.ahs == null) {
            return;
        }
        if (this.afk != null) {
            this.afk.provideContainer(null);
        }
        this.afk = TypeRegistrar.create("ZoomSlider");
        this.afk.provideContainer(this.ahs);
        var a = this.afk;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.t0 = new Rect(0, _this.afk.windowRect.left, _this.dataChart.tk.top, _this.afk.windowRect.width, _this.dataChart.tk.height);
            }
        });
        this.aky();
    };
    FinancialChart.prototype.amd = function (a, b) {
        this.al1(a, b, this.ahr);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.aht == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.af2 ? this.aha : 0) + "px";
        a[1] = this.afy ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.afk != null) {
            if (a[5] == "0px") {
                this.afk.hide();
            }
            else {
                this.afk.show();
            }
        }
        this.aht.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)), "auto", "1fr"));
        this.aht.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)));
        if (this.ka == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.aev != null) {
            this.aev.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.afk != null) {
            this.afk.notifySizeChanged();
        }
    };
    FinancialChart.prototype.sb = function () {
        var e_1, _a;
        _super.prototype.sb.call(this);
        this.wh = 1;
        this.abw = 0;
        this.ye = 0;
        this.acq = null;
        this.acj = AxisDefaults.g;
        this.xy = AxisDefaults.e;
        this.xx = AxisDefaults.f;
        this.ack = AxisDefaults.j;
        this.acg = null;
        this.amh = AxisDefaults.h;
        this.ahn = AxisDefaults.b;
        this.fv = true;
        this.fo = true;
        this.fp = false;
        this.a9 = 0;
        this.ib = Defaults.j;
        this.ur = Defaults.ae;
        this.um = Defaults.af;
        this.un = Defaults.ag;
        this.ix = NaN;
        this.ip = 40;
        this.f4 = true;
        this.gb = false;
        if (this.dataChart != null) {
            var a = this.dataChart.cu.j.e();
            this.add = a.d;
            this.ade = a.e;
            this.adc = a.d;
            this.amh = this.dataChart.x5;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.m(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.adf = c;
        this.adg = b;
    };
    FinancialChart.prototype.alx = function () {
        if (this.aev != null) {
            this.aev.b = null;
            this.aev.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.aly = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.al7 = function () {
        this.alx();
    };
    FinancialChart.prototype.akw = function () {
        if (this.afk == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.ka.rootWrapper.width();
        var b = this.dataChart.tz.left + this.dataChart.tz.width;
        var c = this.dataChart.tz.left;
        var d = a - b;
        this.afk.startInset = c - this.afk.trackStartInset;
        this.afk.endInset = d - this.afk.trackEndInset;
        if (this.afk.endInset < 0) {
            var e = this.afk.endInset;
            this.afk.endInset = 0;
            this.dataChart.g5 += (e * -1);
        }
        if (this.afk.startInset < 0) {
            var f = this.afk.startInset;
            this.afk.startInset = 0;
            this.dataChart.g0 += (f * -1);
        }
        this.zoomSliderChart.g0 = c;
        this.zoomSliderChart.g5 = d;
        this.zoomSliderChart.gn = this.afk.barExtent;
    };
    FinancialChart.prototype.aln = function () {
        this.akw();
    };
    FinancialChart.prototype.r8 = function (a) {
        _super.prototype.r8.call(this, a);
        if (a != null) {
            a.gm = 0;
        }
    };
    FinancialChart.prototype.ami = function (a) {
        return a.td();
    };
    FinancialChart.prototype.aml = function () {
        return this.ahp == null ? null : this.amk(this.ahp.rootWrapper);
    };
    FinancialChart.prototype.amj = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.amk(a.d.rootWrapper);
    };
    FinancialChart.prototype.amk = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.ag5 = function () {
        if (this.aht == null) {
            return NaN;
        }
        var a = this.aht.getOffset();
        return this.aht.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.sk = function (source_, a, b) {
        _super.prototype.sk.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mp(source_, a, b);
        }
    };
    FinancialChart.prototype.sl = function (source_, a, b) {
        _super.prototype.sl.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mq(source_, a, b);
        }
    };
    FinancialChart.prototype.sj = function (source_) {
        _super.prototype.sj.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mi(source_);
        }
    };
    FinancialChart.prototype.sn = function (source_, a, b, c) {
        _super.prototype.sn.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mr(source_, a, b, c);
        }
    };
    FinancialChart.prototype.se = function (a, b) {
        _super.prototype.se.call(this, a, b);
        if (this.afz(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "ad2", {
        get: function () {
            return this.ad1;
        },
        set: function (a) {
            var b = this.ad2;
            if (a != b) {
                this.ad1 = a;
                this.sy("Toolbar", b, this.ad2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aii", {
        get: function () {
            return this.aib;
        },
        set: function (a) {
            var b = this.aii;
            if (a != b) {
                this.aib = a;
                this.sy("RangeSelectorTemplate", b, this.aii);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aij", {
        get: function () {
            return this.aic;
        },
        set: function (a) {
            var b = this.aij;
            if (a != b) {
                this.aic = a;
                this.sy("ToolbarTemplate", b, this.aij);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aif", {
        get: function () {
            return this.ah8;
        },
        set: function (a) {
            var b = this.aif;
            if (a != b) {
                this.ah8 = a;
                this.sy("ChartTypePickerTemplate", b, this.aif);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aik", {
        get: function () {
            return this.aid;
        },
        set: function (a) {
            var b = this.aik;
            if (a != b) {
                this.aid = a;
                this.sy("TrendLineTypePickerTemplate", b, this.aik);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ail", {
        get: function () {
            return this.aie;
        },
        set: function (a) {
            var b = this.ail;
            if (a != b) {
                this.aie = a;
                this.sy("VolumeTypePickerTemplate", b, this.ail);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aig", {
        get: function () {
            return this.ah9;
        },
        set: function (a) {
            var b = this.aig;
            if (a != b) {
                this.ah9 = a;
                this.sy("IndicatorMenuTemplate", b, this.aig);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aih", {
        get: function () {
            return this.aia;
        },
        set: function (a) {
            var b = this.aih;
            if (a != b) {
                this.aia = a;
                this.sy("OverlayPickerTemplate", b, this.aih);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afk", {
        get: function () {
            return this.afj;
        },
        set: function (a) {
            var b = this.afk;
            if (a != b) {
                this.afj = a;
                this.sy("ZoomSlider", b, this.afk);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ip = function () {
        return _super.prototype.get_ip.call(this);
    };
    FinancialChart.prototype.set_ip = function (a) {
        _super.prototype.set_ip.call(this, a);
    };
    FinancialChart.prototype.get_f4 = function () {
        return _super.prototype.get_f4.call(this);
    };
    FinancialChart.prototype.set_f4 = function (a) {
        _super.prototype.set_f4.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "aha", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.agt = a;
                this.sy("ToolbarHeight", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.v6 = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.v7 = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.afk != null) {
            this.afk.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.afk != null) {
            this.afk.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.bc = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_gt = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gt", {
        get: function () {
            return this.get_gt();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_gs = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gs", {
        get: function () {
            return this.get_gs();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ado = function (a) {
        return this.adp(a);
    };
    FinancialChart.prototype.ae2 = function (a) {
        return this.ae3(a);
    };
    FinancialChart.prototype.adn = function (a) {
        var b = this.ado(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.rp = function () {
        this.xAxis = this.adn("xAxis");
        this.yAxis = this.ae2(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ae2(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.adn("volumeXAxis");
        this.agg = new List$1(NumericYAxis.$, 0);
        this.agi = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.ae2(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.adn("indicatorXAxis_0");
        this.agg.add(this.indicatorAxis);
        this.agi.add(this.indicatorXAxis);
        if (this.xAxis.az == null) {
            this.xAxis.az = new AxisLabelSettings();
        }
        if (this.yAxis.az == null) {
            this.yAxis.az = new AxisLabelSettings();
        }
        if (this.volumeAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.volumeXAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorAxis.az == null) {
            this.indicatorAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.az == null) {
            this.indicatorXAxis.az = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ae2(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.adn("zoomSliderXAxis");
        if (this.zoomSliderAxis.az == null) {
            this.zoomSliderAxis.az = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.az == null) {
            this.zoomSliderXAxis.az = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.rl = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.ql = this.cr(a, b);
        }
    };
    FinancialChart.prototype.cq = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.cq.call(this, a);
    };
    FinancialChart.prototype.ti = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.li = true;
            this.yAxis.l9 = 10;
        }
    };
    FinancialChart.prototype.tl = function () {
        this.yAxis.li = this.af9;
        this.yAxis.l9 = this.ah7;
    };
    FinancialChart.prototype.ad6 = function (a) {
        var b;
        if (this.ad4 == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.ad4;
        }
        b = this.ad5(b);
        return b;
    };
    FinancialChart.prototype.ad5 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.aef = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ad8 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.aiu = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.adp = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ae3 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ae9 = function () {
        return this.c3(1);
    };
    FinancialChart.prototype.afa = function () {
        return this.c3(0);
    };
    FinancialChart.prototype.ae8 = function () {
        return this.c3(2);
    };
    FinancialChart.prototype.afb = function () {
        return this.c3(20);
    };
    Object.defineProperty(FinancialChart.prototype, "afs", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeq", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afv", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeo", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aft", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aes", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afu", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aex", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.c1 = function (a, b) {
        var c = this.aiu(a);
        switch (this.ad6(a)) {
            case 3:
                var d = this.ae9();
                this.aeq.setValueMemberPath(d, c);
                this.aeq.setXAxis(d, this.xAxis);
                this.aeq.setYAxis(d, this.yAxis);
                this.aeq.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.afa();
                this.aeq.setValueMemberPath(e, c);
                this.aeq.setXAxis(e, this.xAxis);
                this.aeq.setYAxis(e, this.yAxis);
                this.aeq.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.afb();
                this.aeo.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.aeo.setHighMemberPath(f, a.getMemberPathFor(12));
                this.aeo.setLowMemberPath(f, a.getMemberPathFor(13));
                this.aeo.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.aeo.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.aeo.setXAxis(f, this.xAxis);
                this.aeo.setYAxis(f, this.yAxis);
                this.aeo.setDisplayType(f, this.ad4 == 1 ? 1 : 0);
                this.aeo.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.tk = function () {
        _super.prototype.tk.call(this);
        this.all(this.xAxis);
        this.al9(false);
        if (this.ad9 != 0 && this.volumeChart != null) {
            this.als();
        }
        this.all(this.volumeXAxis);
        this.all(this.indicatorXAxis);
        this.al6();
        this.al8();
        if (this.aeg != 0) {
            this.alt();
            this.all(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abi = function (a, b) {
        var e_2, _a;
        _super.prototype.abi.call(this, a, b);
        a(this.volumeXAxis);
        if (this.agi != null) {
            try {
                for (var _b = __values(fromEnum(this.agi)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abn = function (a, b) {
        var e_3, _a;
        _super.prototype.abn.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.agg != null) {
                try {
                    for (var _b = __values(fromEnum(this.agg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.alp = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.abl = function (a) {
        _super.prototype.abl.call(this, a);
        this.abc(this.volumeXAxis, a);
        this.abc(this.indicatorXAxis, a);
        this.abc(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.abq = function (a) {
        _super.prototype.abq.call(this, a);
        this.abc(this.volumeAxis, a);
        this.abc(this.indicatorAxis, a);
        this.abc(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abo = function (a) {
        _super.prototype.abo.call(this, a);
        this.abb(this.volumeAxis, a);
        this.abb(this.indicatorAxis, a);
        this.abb(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abj = function (a) {
        _super.prototype.abj.call(this, a);
        this.abb(this.volumeXAxis, a);
        this.abb(this.indicatorXAxis, a);
        this.abb(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.r7 = function (a) {
        var _this = this;
        _super.prototype.r7.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.uv = a.uy = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.ajp();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.ci = 2;
    };
    FinancialChart.prototype.ajp = function () {
        if (this.aim == null) {
            FinancialChart.ah6++;
            this.aim = FinancialChart.ah6.toString();
        }
        return this.aim;
    };
    FinancialChart.prototype.ak7 = function (a, b) {
        this.akt();
        this.aln();
    };
    FinancialChart.prototype.akt = function () {
        var e_4, _a;
        if (this.yAxis.b8()) {
            return;
        }
        var a = this.yAxis.aw.bd;
        if (this.ad9 != 0) {
            a = Math.max(a, this.volumeAxis.aw.bd);
        }
        try {
            for (var _b = __values(fromEnum(this.agg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.aw.bd);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.aku(a);
    };
    FinancialChart.prototype.aku = function (a) {
        var e_5, _a;
        if (this.yAxis.b8()) {
            return;
        }
        this.yAxis.es = this.volumeAxis.es = a;
        try {
            for (var _b = __values(fromEnum(this.agg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.es = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.es = this.yAxis.es;
    };
    FinancialChart.prototype.akz = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.afx(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.ak2 = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ak0 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.afz(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.ak1 = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afz(d)) {
                continue;
            }
            var e = this.ah0(d, c);
            a(d, e);
        }
        if (b) {
            this.ak3(a);
        }
    };
    FinancialChart.prototype.ak3 = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ah0 = function (a, b) {
        if (a.cc != this.dataChart) {
            return b;
        }
        var c = this.bd == null || this.bd.dataSeries == null ? 0 : this.bd.dataSeries.count;
        var d = this.aek == null ? 0 : this.aek.count;
        return b - (c * d);
    };
    FinancialChart.prototype.rx = function (a) {
        _super.prototype.rx.call(this, a);
        this.ak2(a);
        this.akz(a);
        this.ak3(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.aff;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.aff = a;
                this.sy("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.als = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afz(d) || d.dd) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.ad9;
            f = this.ad8(f);
            switch (f) {
                case 2:
                    e = this.afa();
                    break;
                case 3:
                    e = this.ae8();
                    break;
                default:
                case 1:
                    e = this.ae9();
                    break;
            }
            this.aeq.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.aeq.setXAxis(e, this.volumeXAxis);
            this.aeq.setYAxis(e, this.volumeAxis);
            this.aeq.setValueMemberPath(e, this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > b ? this.bd.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.o9 = ArrayExtension.getModulus$1(Brush.$, this.adh, b);
            e.pe = ArrayExtension.getModulus$1(Brush.$, this.adi, b);
            e.g4 = this.ahb;
            a.add(e);
        }
        var g = this.gp("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.sc(i, h);
        }
    };
    FinancialChart.prototype.afw = function (a) {
        if (!this.afs) {
            return false;
        }
        return this.aeq.matchesType(a);
    };
    FinancialChart.prototype.af0 = function (a) {
        if (!this.afv) {
            return false;
        }
        return this.aeo.matchesType(a);
    };
    FinancialChart.prototype.afx = function (a) {
        if (!this.aft) {
            return false;
        }
        return this.aes.matchesType(a);
    };
    FinancialChart.prototype.afz = function (a) {
        if (!this.afu) {
            return false;
        }
        return this.aex.matchesType(a);
    };
    FinancialChart.prototype.alr = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.aei == null ? 0 : this.aei.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aei._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.afz(l) || l.dd) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.afc("Custom");
                    this.aes.handleCustomIndicatorEvent(n, runOn(this, this.ak5));
                    m = n;
                }
                else {
                    m = this.afe(this.aei._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.aes.setXAxis(m, this.agi._inner[e]);
                this.aes.setYAxis(m, this.agg._inner[e]);
                m.itemsSource = l.itemsSource;
                this.aes.setOpenMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(11));
                this.aes.setHighMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(12));
                this.aes.setLowMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(13));
                this.aes.setCloseMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(14));
                this.aes.setVolumeMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.o9 = ArrayExtension.getModulus$1(Brush.$, this.adb, e);
                m.g4 = this.ag7;
                if (this.afx(m)) {
                    this.aes.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.adc, e));
                    this.aes.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aeu, e));
                }
                if (this.ah2 != -2147483648 && this.afx(m)) {
                    this.aes.setPeriodOverride(m, this.ah2);
                }
                if (this.afx(m)) {
                    this.aes.setSmoothingPeriod(m, this.ah5);
                }
                if (this.afx(m)) {
                    this.aes.setSignalPeriod(m, this.ah4);
                }
                if (this.afx(m)) {
                    this.aes.setShortPeriod(m, this.ah3);
                    this.aes.setLongPeriod(m, this.ah1);
                }
                this.sc(m, e);
                f.add(m);
            }
            var o = this.gp(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.sc(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.afc = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.afe = function (a) {
        return this.afc(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.al9 = function (a) {
        if (this.ad2 == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.ad2.as = b.actualMinimumValue;
        this.ad2.ar = b.actualMaximumValue;
        if (a) {
            this.ad2.au = b.visibleMinimum;
            this.ad2.at = b.visibleMaximum;
        }
        this.ad2.bn();
    };
    FinancialChart.prototype.kb = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.kb.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.v7();
            $ret.toolbar = _this.ad2 == null ? null : _this.ad2.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.v7();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.v7());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.ami(this.dataChart).x;
            a.mainChartTop = this.ami(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.ami(this.volumeChart).x;
            a.volumeChartTop = this.ami(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.ami(this.zoomSliderChart).x;
            a.zoomChartTop = this.ami(this.zoomSliderChart).y;
        }
        if (this.ad2 != null) {
            var c = this.amj(this.ad2);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.ami(d).x);
                    a.indicatorChartTops.add(this.ami(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.aml();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.aem == null ? null : this.aem.exportVisualData();
        return a;
    };
    FinancialChart.prototype.air = function () {
        var a = this.kb();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.afd = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.al8 = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.afz(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.aek == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.afz(g) || g.dd) {
                continue;
            }
            e++;
            for (var h = 0; h < this.aek.count; h++) {
                var i = this.aek._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.afd(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.afd(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.aex.setXAxis(j, this.xAxis);
                this.aex.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.aek.count + h;
                j.o9 = ArrayExtension.getModulus$1(Brush.$, this.adf, k);
                j.pe = ArrayExtension.getModulus$1(Brush.$, this.adg, k);
                j.g4 = this.ag9;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.bd.dataSeries._inner[e];
                this.aex.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.aex.setHighMemberPath(j, m.getMemberPathFor(12));
                this.aex.setLowMemberPath(j, m.getMemberPathFor(13));
                this.aex.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.aex.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.sc(q, p);
        }
    };
    FinancialChart.prototype.al6 = function () {
        var e_10, _a;
        if (this.af5) {
            return;
        }
        this.af5 = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.alm(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.aei == null || this.aei.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.agg != null) {
                this.agg.clear();
            }
            if (this.agi != null) {
                this.agi.clear();
            }
            this.alx();
            this.al7();
            this.af5 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.agg.clear();
        this.agi.clear();
        var c = this.aei == null ? 0 : this.aei.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.alk(g);
            var h = f >= c;
            if (h) {
                g.kl = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.kl = this.ait(this.aei._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.ce) {
                        j = this.ado(0);
                    }
                    else {
                        j = this.ado(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.agg.add(i);
                this.agi.add(j);
                if (this.fk) {
                    this.abf(i);
                }
                if (this.fk) {
                    this.abd(j);
                }
            }
        }
        this.alr();
        this.alx();
        if (this.ad2 != null) {
            this.ad2.ae = this.aei;
        }
        this.akv();
        this.al7();
        this.af5 = false;
    };
    FinancialChart.prototype.r4 = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.r4.call(this);
        this.abd(this.xAxis);
        this.abd(this.volumeXAxis);
        if (this.agi != null) {
            try {
                for (var _c = __values(fromEnum(this.agi)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.abd(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.abf(this.yAxis);
        this.abf(this.volumeAxis);
        if (this.agg != null) {
            try {
                for (var _e = __values(fromEnum(this.agg)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.abf(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.abd(this.zoomSliderXAxis);
        this.abf(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_ga = function () {
        return !this.af3;
    };
    Object.defineProperty(FinancialChart.prototype, "agb", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ame = function (a, b) {
        this.al0(a, b);
        this.akv();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.alt();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.aly();
        this.amf(a, b);
    };
    FinancialChart.prototype.alt = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.afz(c) || c.dd) {
                continue;
            }
            var d = void 0;
            var e = this.aeg;
            e = this.aef(e);
            var f = this.ah0(c, b);
            if (e == 1) {
                switch (this.ad6(this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.afb();
                    this.aeo.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.afb();
                    this.aeo.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.afa();
                    break;
                case 6:
                    d = this.ae8();
                    break;
                default:
                case 4:
                    d = this.ae9();
                    break;
            }
            var g = this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null;
            if (d.dj && !d.ds) {
                this.aeq.setCategoryMode(d, 1);
                this.aeq.setXAxis(d, this.zoomSliderXAxis);
                this.aeq.setYAxis(d, this.zoomSliderAxis);
                this.aeq.setValueMemberPath(d, g == null ? null : this.aiu(g));
            }
            else if (d.ds) {
                this.aeo.setCategoryMode(d, 1);
                this.aeo.setXAxis(d, this.zoomSliderXAxis);
                this.aeo.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.aeo.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.aeo.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.aeo.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.aeo.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.aeo.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.g4 = this.i3;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.sc(i, h);
        }
    };
    FinancialChart.prototype.ss = function (a, b, c) {
        var e_13, _a;
        _super.prototype.ss.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.ak5 = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.cc);
        }
        e -= this.aei == null ? 0 : this.aei.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.al2 = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.fk) {
            this.abd(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "aga", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ak6 = function (a, b) {
        this.al6();
    };
    FinancialChart.prototype.af1 = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.alw = function () {
        var e_14, _a;
        var a = this.ad0 != null ? this.ad0 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.af1(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.adz = b;
        if (this.ad2 != null) {
            this.ad2.u = this.adz;
        }
    };
    FinancialChart.prototype.ala = function (a, b) {
        this.alw();
    };
    FinancialChart.prototype.alf = function (a, b) {
        this.aek = this.ad2.ag;
    };
    FinancialChart.prototype.ale = function (a, b) {
        this.aei = this.ad2.ae;
    };
    FinancialChart.prototype.ak8 = function (a, b) {
        this.al6();
    };
    FinancialChart.prototype.ak9 = function (a, b) {
        this.al8();
    };
    FinancialChart.prototype.alj = function (a, b) {
        var c = a;
        if (c.bg == null) {
            return;
        }
        if (this.af3) {
            this.alv(c.bg);
        }
    };
    FinancialChart.prototype.alm = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ak7));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.es = this.volumeAxis.es = this.indicatorAxis.es = 0;
            this.xAxis.az.visibility = this.ac1;
        }
    };
    FinancialChart.prototype.alk = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.t0 = new Rect(0, this.dataChart.tk.x, a.t0.y, this.dataChart.tk.width, a.t0.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ak7));
        this.r6(a);
    };
    FinancialChart.prototype.akv = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.abb(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.agi._inner[a];
            var c = a < this_1.agi.count - 1 || this_1.volumeChart != null;
            this_1.abb(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.agi.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.al0 = function (a, b) {
        if (a != null) {
            this.alm(a);
        }
        if (b != null) {
            this.alk(b);
        }
    };
    FinancialChart.prototype.amc = function (a, b) {
        this.al0(a, b);
        this.akv();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.als();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.amd(a, b);
    };
    FinancialChart.prototype.alb = function (a, b) {
        this.ama();
    };
    FinancialChart.prototype.ama = function () {
        if (this.ad2 == null || +(this.ad2.au) == +(dateMaxValue()) || +(this.ad2.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.ad2.au, this.ad2.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.af4 = true;
        this.dataChart.t0 = new Rect(0, b.left, this.dataChart.t0.top, b.width, this.dataChart.t0.height);
        if (this.afk != null) {
            this.afk.windowRect = this.dataChart.tk;
        }
        if (this.af3) {
            this.alv(this.dataChart);
        }
        this.af4 = false;
    };
    FinancialChart.prototype.ali = function (a, b) {
        this.alw();
        this.al9(!this.af4);
    };
    FinancialChart.prototype.ak4 = function (a, b) {
        var _this = this;
        if (!this.af4) {
            if (this.af3) {
                this.alv(a);
            }
            var c = false;
            var d = this.s5(function () { return _this.al9(true); }, c);
            c = d.p1;
            if (this.afk != null) {
                this.afk.windowRect = this.dataChart.tk;
            }
        }
    };
    FinancialChart.prototype.al4 = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.af4 = true;
            a.t0 = new Rect(0, d, a.tk.top, c, a.tk.height);
            this.af4 = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ch, a.to);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.gg();
                var j = i.ar(a.tk);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.ej(j.c, h);
                var m = b.ej(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.tk.width;
        if (c != -1) {
            n = c;
        }
        var o = a.tk.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.af4 = true;
        var p = new Rect(0, o, e, n, f - e);
        a.t0 = p;
        this.af4 = false;
    };
    FinancialChart.prototype.al3 = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.al4(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.al4(this.volumeChart, this.volumeAxis, this.dataChart.tk.width, this.dataChart.tk.left);
            }
        }
        else if (a == this.volumeChart) {
            this.al4(this.volumeChart, this.volumeAxis, -1, -1);
            this.al4(this.dataChart, this.yAxis, this.volumeChart.tk.width, this.volumeChart.tk.left);
        }
    };
    FinancialChart.prototype.alv = function (a) {
        var _this = this;
        this.s4(function () { return _this.al3(a); });
    };
    FinancialChart.prototype.alc = function (a, b) {
        if (this.af3) {
            this.alv(a);
        }
    };
    FinancialChart.prototype.amb = function () {
        if (!this.agb) {
            return;
        }
        this.aky();
        if (this.aeg == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.alt();
        }
    };
    FinancialChart.prototype.aky = function () {
        var container_ = this.ahs.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.afk != null && containerParent_ != null && !this.agc) {
            this.agc = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.afk;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.al5 = function () {
        var _this = this;
        if (this.aeb != 1) {
            return;
        }
        this.abh(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.tq = function (a, b, c) {
        _super.prototype.tq.call(this, a, b, c);
        if (this.bd.dataSeries.count > 0) {
            if (this.aeb == 1 && stringIsNullOrEmpty(this.lo)) {
                this.b3.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.lq)) {
                this.b3.setYMemberPath(a, this.aiu(c));
            }
            if (stringIsNullOrEmpty(this.lk)) {
                this.b3.setLabelMemberPath(a, this.aiu(c));
            }
            if (stringIsNullOrEmpty(this.lh)) {
                this.b3.setContentMemberPath(a, this.aiu(c));
            }
        }
    };
    FinancialChart.prototype.ait = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.abd = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.abd.call(this, a);
        var b = a;
        this.all(b);
        if (a.bg != null) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.afw(c)) {
                        this.aeq.setXAxis(c, b);
                    }
                    else if (this.af0(c)) {
                        this.aeo.setXAxis(c, b);
                    }
                    else if (this.afx(c)) {
                        this.aes.setXAxis(c, b);
                    }
                    else if (this.afz(c)) {
                        this.aex.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.alp(function (d) {
            d.zoomMaximumCategoryRange = _this.ahc;
            d.zoomMaximumItemSpan = _this.ahd;
            d.zoomToCategoryRange = _this.ahe;
            d.zoomToCategoryStart = _this.ahf;
            d.zoomToItemSpan = _this.ahg;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jw = this.amh;
            a.er = this.ahn;
            this.abb(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.ago;
        e.maximumValue = this.agn;
        a.b1 = this.af6;
    };
    FinancialChart.prototype.abf = function (a) {
        var e_18, _a;
        _super.prototype.abf.call(this, a);
        if (a.bg != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.afw(b)) {
                        this.aeq.setYAxis(b, this.yAxis);
                    }
                    else if (this.af0(b)) {
                        this.aeo.setYAxis(b, this.yAxis);
                    }
                    else if (this.afx(b)) {
                        this.aes.setYAxis(b, this.yAxis);
                    }
                    else if (this.afz(b)) {
                        this.aex.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.la = this.af7;
        a.l5 = this.ahl;
        a.l4 = this.ahk;
        if (a == this.yAxis) {
            a.l1 = this.ahj;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.abb(a, function (d) { return d.visibility = 1; });
        }
        a.b1 = this.af8;
    };
    FinancialChart.prototype.all = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.f0 = XYChart.y0(a, this.bd.dataSeries);
        if (this.bd.dataSeries.count > 0) {
            var b = this.bd.dataSeries._inner[0].getMemberPathFor(17);
            a.hy(b);
        }
    };
    FinancialChart.prototype.sc = function (a, b) {
        _super.prototype.sc.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.cc;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.d6) {
            a.ms(this.add != null ? ArrayExtension.getModulus$1(Brush.$, this.add, b) : null, this.ade != null ? ArrayExtension.getModulus$1(Brush.$, this.ade, b) : null);
        }
        var e = this.afx(a);
        if (this.afz(a)) {
            a.o9 = this.adf != null ? ArrayExtension.getModulus$1(Brush.$, this.adf, b) : null;
            a.pe = this.adg != null ? ArrayExtension.getModulus$1(Brush.$, this.adg, b) : null;
            a.g4 = this.ag9;
        }
        else if (e) {
            a.o9 = this.adb != null ? ArrayExtension.getModulus$1(Brush.$, this.adb, b) : null;
            a.g4 = this.ag7;
        }
        else if (!a.dd && (d || c)) {
            a.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, b) : null;
            a.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.cc;
        if (f) {
            a.g4 = this.ahb;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.afy ? this.aem : null;
    };
    FinancialChart.prototype.sy = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.sy.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.li = this.af9;
                if (this.volumeAxis != null) {
                    this.volumeAxis.li = this.af9;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.li = this.af9;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.l9 = this.ah7;
                if (this.volumeAxis != null) {
                    this.volumeAxis.l9 = this.ah7;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.l9 = this.ah7;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.ad9 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.als();
                }
                break;
            case "VolumeChart":
                this.amc(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ak7));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ak4));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.alc));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ak7));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ak4));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.alc));
                }
                this.amb();
                break;
            case "XAxisMode":
                this.xAxis = this.ado(this.aeb);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.ado(this.aeb);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.ado(this.aeb);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.ado(this.aeb);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.abb(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.akv();
                if (this.aeb == 1) {
                    this.al5();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.ae2(this.aed);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.ae2(this.aed);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.ae2(this.aed);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.alb));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ale));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.alf));
                }
                if (this.ad2 != null) {
                    this.ad2.ae = this.aei;
                    this.ad2.ag = this.aek;
                    this.ad2.u = this.adz;
                    this.al9(true);
                    var j = this.ad2;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.alb));
                    var k = this.ad2;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ale));
                    var l = this.ad2;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.alf));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.ali));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.fk) {
                    this.abd(this.xAxis);
                    this.ru();
                }
                this.al9(false);
                this.ama();
                this.alw();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.ali));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.alp(function (p) { return p.zoomMaximumCategoryRange = _this.ahc; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.alp(function (p) { return p.zoomMaximumItemSpan = _this.ahd; });
                break;
            case "XAxisZoomToCategoryRange":
                this.alp(function (p) { return p.zoomToCategoryRange = _this.ahe; });
                break;
            case "XAxisZoomToCategoryStart":
                this.alp(function (p) { return p.zoomToCategoryStart = _this.ahf; });
                break;
            case "XAxisZoomToItemSpan":
                this.alp(function (p) { return p.zoomToItemSpan = _this.ahg; });
                break;
            case "ChartType":
                this.tk();
                break;
            case "VolumeXAxis":
                this.al2(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.al2(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.al6();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.fk) {
                    this.abf(this.yAxis);
                    this.abf(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.alj));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.als();
                }
                if (this.fk) {
                    this.abf(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.alj));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.aed == 1) {
                            y = this.ae2(this.aed);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.fk) {
                            this.abf(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.uy = this.gb && this.ga;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.uy = this.gb && this.ga;
                }
                if (this.af3) {
                    this.al3(this.dataChart);
                }
                else {
                    this.volumeChart.v5 = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ak8));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ak8));
                }
                this.al6();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ak9));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ak9));
                }
                this.al8();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.abm(function (ad) { return ad.la = _this.af7; });
                break;
            case "YAxisMinimumValue":
                this.abn(function (ad) { return ad.l5 = _this.ahl; }, false);
                break;
            case "YAxisMaximumValue":
                this.abn(function (ad) { return ad.l4 = _this.ahk; }, false);
                break;
            case "YAxisInterval":
                this.abn(function (ad) { return ad.l1 = _this.ahj; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.amb();
                break;
            case "ZoomSliderChart":
                if (!this.aga) {
                    return;
                }
                this.ame(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.ak1(function (ad, ae) {
                    if (ad.d6) {
                        ad.ms(_this.add != null ? ArrayExtension.getModulus$1(Brush.$, _this.add, ae) : null, _this.ade != null ? ArrayExtension.getModulus$1(Brush.$, _this.ade, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.ak0(function (ad, ae) { return ad.o9 = _this.adf != null ? ArrayExtension.getModulus$1(Brush.$, _this.adf, ae) : null; });
                break;
            case "OverlayOutlines":
                this.ak0(function (ad, ae) { return ad.pe = _this.adg != null ? ArrayExtension.getModulus$1(Brush.$, _this.adg, ae) : null; });
                break;
            case "OverlayThickness":
                this.ak0(function (ad, ae) { return ad.g4 = _this.ag9; });
                break;
            case "OverlayMultiplier":
                this.ak0(function (ad, ae) { return _this.aex.setMultiplier(ad, _this.ag8); });
                break;
            case "VolumeBrushes":
                this.ak2(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.adh, ae); });
                break;
            case "VolumeOutlines":
                this.ak2(function (ad, ae) { return ad.pe = ArrayExtension.getModulus$1(Brush.$, _this.adi, ae); });
                break;
            case "VolumeThickness":
                this.ak2(function (ad, ae) { return ad.g4 = _this.ahb; });
                break;
            case "IndicatorNegativeBrushes":
                this.akz(function (ad, ae) { return _this.aes.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.adc, ae)); });
                break;
            case "IndicatorBrushes":
                this.akz(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.adb, ae); });
                break;
            case "IndicatorThickness":
                this.akz(function (ad, ae) { return ad.g4 = _this.ag7; });
                break;
            case "IndicatorDisplayTypes":
                this.akz(function (ad, ae) { return _this.aes.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.aeu, ae)); });
                break;
            case "IndicatorPeriod":
                this.akz(function (ad, ae) {
                    if (_this.ah2 == -2147483648) {
                        return;
                    }
                    _this.aes.setPeriodOverride(ad, _this.ah2);
                });
                break;
            case "IndicatorMultiplier":
                this.akz(function (ad, ae) { return _this.aes.setMultiplier(ad, _this.ag6); });
                break;
            case "IndicatorSmoothingPeriod":
                this.akz(function (ad, ae) { return _this.aes.setSmoothingPeriod(ad, _this.ah5); });
                break;
            case "IndicatorShortPeriod":
                this.akz(function (ad, ae) { return _this.aes.setShortPeriod(ad, _this.ah3); });
                break;
            case "IndicatorLongPeriod":
                this.akz(function (ad, ae) { return _this.aes.setLongPeriod(ad, _this.ah1); });
                break;
            case "IndicatorSignalPeriod":
                this.akz(function (ad, ae) { return _this.aes.setSignalPeriod(ad, _this.ah4); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ala));
                }
                if (this.ad0 != null) {
                    var ae = this.ad0;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ala));
                }
                this.alw();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.ak6));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.ak6));
                }
                this.al6();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.ak1(function (ah, ai) { return ah.o9 = _this.ab != null ? ArrayExtension.getModulus$1(Brush.$, _this.ab, ai) : null; }, true);
                break;
            case "Outlines":
                this.ak1(function (ah, ai) { return ah.pe = _this.af != null ? ArrayExtension.getModulus$1(Brush.$, _this.af, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ac1 == 0 && this.zoomSliderXAxis != null) {
                    this.abb(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.akv();
                break;
            case "YAxisLabelVisibility":
                if (this.ac2 != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.abb(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jw = this.amh;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.er = this.ahn;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.afy && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.aem : null;
                        }
                    };
                    this.ak1(ai, false);
                    this.ak0(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.alt();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.fk) {
                        this.abf(this.zoomSliderAxis);
                    }
                    this.abb(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.abh(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.ago;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.abh(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.agn;
                    }
                });
                break;
            case FinancialChart.aj2:
                this.abi(function (ak) { return ak.b1 = _this.af6; }, a);
                break;
            case FinancialChart.akd:
                this.abm(function (ak) { return ak.b1 = _this.af8; });
                break;
        }
    };
    FinancialChart.prototype.get_b1 = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "b1", {
        get: function () {
            return this.get_b1();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af9", {
        get: function () {
            return this.afr;
        },
        set: function (a) {
            var b = this.af9;
            if (a != b) {
                this.afr = a;
                this.sy("YAxisIsLogarithmic", b, this.af9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah7", {
        get: function () {
            return this.ahz;
        },
        set: function (a) {
            var b = this.ah7;
            if (a != b) {
                this.ahz = a;
                this.sy("YAxisLogarithmBase", b, this.ah7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahj", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag0 = a;
                this.sy("YAxisInterval", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahl", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag2 = a;
                this.sy("YAxisMinimumValue", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahk", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag1 = a;
                this.sy("YAxisMaximumValue", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahm", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.ahm;
            if (a != b) {
                this.ag3 = a;
                this.sy("YAxisMinorInterval", b, this.ahm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahi", {
        get: function () {
            return this.yAxis.lx;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahh", {
        get: function () {
            return this.yAxis.lw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad9", {
        get: function () {
            return this.ad7;
        },
        set: function (a) {
            var b = this.ad9;
            if (a != b) {
                this.ad7 = a;
                this.sy("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ad9));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeb", {
        get: function () {
            return this.aea;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.aea = a;
                this.sy("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.aeb));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahc", {
        get: function () {
            return this.agv;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.agv = a;
                this.sy("XAxisZoomMaximumCategoryRange", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahf", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agy = a;
                this.sy("XAxisZoomToCategoryStart", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahd", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.agw = a;
                this.sy("XAxisZoomMaximumItemSpan", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahe", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.agx = a;
                this.sy("XAxisZoomToCategoryRange", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahg", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.agz = a;
                this.sy("XAxisZoomToItemSpan", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aed", {
        get: function () {
            return this.aec;
        },
        set: function (a) {
            var b = this.aed;
            if (a != b) {
                this.aec = a;
                this.sy("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.aed));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af2", {
        get: function () {
            return this.afm;
        },
        set: function (a) {
            var b = this.af2;
            if (a != b) {
                this.afm = a;
                this.sy("IsToolbarVisible", b, this.af2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad4", {
        get: function () {
            return this.ad3;
        },
        set: function (a) {
            var b = this.ad4;
            if (a != b) {
                this.ad3 = a;
                this.sy("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ad4));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_abw = function () {
        return _super.prototype.get_abw.call(this);
    };
    FinancialChart.prototype.set_abw = function (a) {
        _super.prototype.set_abw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "af3", {
        get: function () {
            return this.afn;
        },
        set: function (a) {
            var b = this.af3;
            if (a != b) {
                this.afn = a;
                this.sy("IsWindowSyncedToVisibleRange", b, this.af3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aei", {
        get: function () {
            return this.aeh;
        },
        set: function (a) {
            var b = this.aei;
            if (a != b) {
                this.aeh = a;
                this.sy("IndicatorTypes", b, this.aei);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aek", {
        get: function () {
            return this.aej;
        },
        set: function (a) {
            var b = this.aek;
            if (a != b) {
                this.aej = a;
                this.sy("OverlayTypes", b, this.aek);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.age;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.age = a;
                this.sy("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af7", {
        get: function () {
            return this.afp;
        },
        set: function (a) {
            var b = this.af7;
            if (a != b) {
                this.afp = a;
                this.sy("YAxisAbbreviateLargeNumbers", b, this.af7);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ix = function () {
        return _super.prototype.get_ix.call(this);
    };
    FinancialChart.prototype.set_ix = function (a) {
        _super.prototype.set_ix.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "af6", {
        get: function () {
            return this.afo;
        },
        set: function (a) {
            var b = this.af6;
            if (a != b) {
                this.afo = a;
                this.sy(FinancialChart.aj2, b, this.af6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af8", {
        get: function () {
            return this.afq;
        },
        set: function (a) {
            var b = this.af8;
            if (a != b) {
                this.afq = a;
                this.sy(FinancialChart.akd, b, this.af8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.afg;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.afg = a;
                this.sy("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.ae1;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.ae1 = a;
                this.sy("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.adm;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.adm = a;
                this.sy("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeg", {
        get: function () {
            return this.aee;
        },
        set: function (a) {
            var b = this.aeg;
            if (a != b) {
                this.aee = a;
                this.sy("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aeg));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "add", {
        get: function () {
            return this.ac5;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ac5 = a;
                this.sy("NegativeBrushes", b, this.add);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ade", {
        get: function () {
            return this.ac6;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.ac6 = a;
                this.sy("NegativeOutlines", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adf", {
        get: function () {
            return this.ac7;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.ac7 = a;
                this.sy("OverlayBrushes", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adg", {
        get: function () {
            return this.ac8;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.ac8 = a;
                this.sy("OverlayOutlines", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adi", {
        get: function () {
            return this.ada;
        },
        set: function (a) {
            var b = this.adi;
            if (a != b) {
                this.ada = a;
                this.sy("VolumeOutlines", b, this.adi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adh", {
        get: function () {
            return this.ac9;
        },
        set: function (a) {
            var b = this.adh;
            if (a != b) {
                this.ac9 = a;
                this.sy("VolumeBrushes", b, this.adh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adc", {
        get: function () {
            return this.ac4;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.ac4 = a;
                this.sy("IndicatorNegativeBrushes", b, this.adc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adb", {
        get: function () {
            return this.ac3;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ac3 = a;
                this.sy("IndicatorBrushes", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahb", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.ahb;
            if (a != b) {
                this.agu = a;
                this.sy("VolumeThickness", b, this.ahb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag9", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.ags = a;
                this.sy("OverlayThickness", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag8", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.ag8;
            if (a != b) {
                this.agr = a;
                this.sy("OverlayMultiplier", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag7", {
        get: function () {
            return this.agq;
        },
        set: function (a) {
            var b = this.ag7;
            if (a != b) {
                this.agq = a;
                this.sy("IndicatorThickness", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeu", {
        get: function () {
            return this.aet;
        },
        set: function (a) {
            var b = this.aeu;
            if (a != b) {
                this.aet = a;
                this.sy("IndicatorDisplayTypes", b, this.aeu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah2", {
        get: function () {
            return this.ahv;
        },
        set: function (a) {
            var b = this.ah2;
            if (a != b) {
                this.ahv = a;
                this.sy("IndicatorPeriod", b, this.ah2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag6", {
        get: function () {
            return this.agp;
        },
        set: function (a) {
            var b = this.ag6;
            if (a != b) {
                this.agp = a;
                this.sy("IndicatorMultiplier", b, this.ag6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah5", {
        get: function () {
            return this.ahy;
        },
        set: function (a) {
            var b = this.ah5;
            if (a != b) {
                this.ahy = a;
                this.sy("IndicatorSmoothingPeriod", b, this.ah5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah3", {
        get: function () {
            return this.ahw;
        },
        set: function (a) {
            var b = this.ah3;
            if (a != b) {
                this.ahw = a;
                this.sy("IndicatorShortPeriod", b, this.ah3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah1", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ah1;
            if (a != b) {
                this.ahu = a;
                this.sy("IndicatorLongPeriod", b, this.ah1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah4", {
        get: function () {
            return this.ahx;
        },
        set: function (a) {
            var b = this.ah4;
            if (a != b) {
                this.ahx = a;
                this.sy("IndicatorSignalPeriod", b, this.ah4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad0", {
        get: function () {
            return this.ady;
        },
        set: function (a) {
            var b = this.ad0;
            if (a != b) {
                this.ady = a;
                this.sy("RangeSelectorOptions", b, this.ad0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.adu;
        },
        set: function (a) {
            var b = this.adu;
            if (a != b) {
                this.adu = a;
                this.sy("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_gb = function () {
        return _super.prototype.get_gb.call(this);
    };
    FinancialChart.prototype.set_gb = function (a) {
        _super.prototype.set_gb.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "amh", {
        get: function () {
            return this.amg;
        },
        set: function (a) {
            var b = this.amh;
            if (a != b) {
                this.amg = a;
                this.sy("ZoomSliderXAxisMajorStroke", b, this.amh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahn", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahn;
            if (a != b) {
                this.ag4 = a;
                this.sy("ZoomSliderXAxisMajorStrokeThickness", b, this.ahn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afy", {
        get: function () {
            return this.afl;
        },
        set: function (a) {
            var b = this.afy;
            if (a != b) {
                this.afl = a;
                this.sy("IsLegendVisible", b, this.afy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aem", {
        get: function () {
            return this.ael;
        },
        set: function (a) {
            var b = this.aem;
            if (a != b) {
                this.ael = a;
                this.sy("FinancialChartLegend", b, this.aem);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.adl;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.adl = a;
                this.sy("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.ae0;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.ae0 = a;
                this.sy("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.aez;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.aez = a;
                this.sy("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.adk;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.adk = a;
                this.sy("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.aey;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.aey = a;
                this.sy("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.adj = a;
                this.sy("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agg", {
        get: function () {
            return this.agd;
        },
        set: function (a) {
            var b = this.agg;
            if (a != b) {
                this.agd = a;
                this.sy("IndicatorAxes", b, this.agg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agi", {
        get: function () {
            return this.agf;
        },
        set: function (a) {
            var b = this.agi;
            if (a != b) {
                this.agf = a;
                this.sy("IndicatorXAxes", b, this.agi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ago", {
        get: function () {
            return this.agm;
        },
        set: function (a) {
            var b = this.ago;
            if (+a != +b) {
                this.agm = a;
                this.sy("XAxisMinimumValue", b, this.ago);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agn", {
        get: function () {
            return this.agl;
        },
        set: function (a) {
            var b = this.agn;
            if (+a != +b) {
                this.agl = a;
                this.sy("XAxisMaximumValue", b, this.agn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.agj;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ah6 = 0;
    FinancialChart.aj2 = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.akd = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.aii : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.aif : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.aig : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
