import { Base, INotifyPropertyChanged, Type, IEnumerable, PropertyChangedEventArgs } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-react-core";
import { ToolCommandStateChanged } from "igniteui-react-core";
import { ToolCommand } from "igniteui-react-core";
import { DataToolTipLayerGroupingMode } from "igniteui-react-core";
import { DataTooltipGroupedPositionX } from "igniteui-react-core";
import { DataTooltipGroupedPositionY } from "igniteui-react-core";
import { DataAbbreviationMode } from "igniteui-react-core";
import { DataLegendValueMode } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DataLegendHeaderDateMode } from "igniteui-react-core";
import { DataLegendHeaderTimeMode } from "igniteui-react-core";
import { DataLegendSummaryType } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { DataLegendUnitsMode } from "igniteui-react-core";
import { DataLegendLabelMode } from "igniteui-react-core";
import { DomainType } from "./DomainType";
import { ChartSortDescriptionCollection } from "./ChartSortDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-react-core";
import { ChartSummaryDescriptionCollection } from "./ChartSummaryDescriptionCollection";
import { BrushCollection } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { UnknownValuePlotting } from "igniteui-react-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { TrendLineType } from "igniteui-react-core";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { ValueModeCollection } from "./ValueModeCollection";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Series } from "./Series";
import { IDataLegend } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { DataSeries } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ObservableColorCollection } from "igniteui-react-core";
import { DataSeriesMarker } from "igniteui-react-core";
import { IDataLegendSeries } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolCommandExecutionState } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged, IDataLegendTarget, IToolbarTarget {
    static $t: Type;
    protected ka: any;
    provideContainer(a: any): void;
    destroy(): void;
    private sa;
    protected sb(): void;
    protected r7(a: XamDataChart): void;
    protected r4(): void;
    protected sd(a: Series, b: number): void;
    protected s1(a: string, b: any, c: any): void;
    private j8;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private gn;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private hf;
    get is(): number;
    set is(a: number);
    private j7;
    private get toolTip();
    private set toolTip(value);
    private hs;
    get i5(): number;
    set i5(a: number);
    private ht;
    get i6(): number;
    set i6(a: number);
    private hu;
    get i7(): number;
    set i7(a: number);
    private hr;
    get i4(): number;
    set i4(a: number);
    private hn;
    get i0(): number;
    set i0(a: number);
    private hp;
    get i2(): number;
    set i2(a: number);
    private ho;
    get i1(): number;
    set i1(a: number);
    private hm;
    get iz(): number;
    set iz(a: number);
    private ui;
    get va(): Brush;
    set va(a: Brush);
    private uj;
    get vb(): Brush;
    set vb(a: Brush);
    private hc;
    protected get_ip(): number;
    protected set_ip(a: number): void;
    get ip(): number;
    set ip(a: number);
    private hv;
    get i8(): number;
    set i8(a: number);
    private hl;
    get iy(): number;
    set iy(a: number);
    private gz;
    get ia(): number;
    set ia(a: number);
    private jv;
    get j3(): number;
    set j3(a: number);
    private d2;
    get d3(): (time: number) => number;
    set d3(a: (time: number) => number);
    protected r8(a: XamDataChart): void;
    protected se(a: Series, b: number): void;
    protected r5(): void;
    private sf;
    jm: (arg1: HTMLElement) => any[];
    private tr;
    private kc;
    private gc;
    private jn;
    protected s2(a: string, b: any, c: any): void;
    private b9;
    get ca(): IDomainChartWidget;
    set ca(a: IDomainChartWidget);
    private k4;
    get p9(): string;
    set p9(a: string);
    private k6;
    get qk(): string;
    set qk(a: string);
    private dv;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    bd: DataSeriesAdapterImplementation;
    private e4;
    private e3;
    get isDetached(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected r9(): void;
    protected abstract get gt(): List$1<DataSeriesType>;
    protected abstract get gs(): List$1<IDataSeriesAdapterRule>;
    protected gr: List$1<MarkerType>;
    protected f7(a: DataSeriesType): boolean;
    notifyResized(): void;
    so(): void;
    ru(): void;
    r2(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected s8(a: string): void;
    protected abstract rv(a: (arg1: Axis) => void, b: boolean): void;
    protected rw(a: (arg1: Series) => void): void;
    protected rx(a: (arg1: Series, arg2: number) => void): void;
    protected r0(a: (arg1: Series) => void): void;
    protected r1(a: (arg1: Series, arg2: number) => void): void;
    protected ry(a: (arg1: Series) => void): void;
    protected rz(a: (arg1: Series, arg2: number) => void): void;
    th(): void;
    protected sq(a: (arg1: XamDataChart) => void): void;
    protected sr(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected ss(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected f9(a: DataSeries): boolean;
    protected f0(): boolean;
    private static readonly kk;
    private ju;
    protected og(a: DataSeries): string;
    private static kj;
    protected oh(a: DataSeries, b: DataSeriesType): string;
    protected abstract bc(a: DataSeries): DataSeriesType;
    protected abstract c1(a: DataSeries, b: DataSeriesType): Series;
    of(): string;
    private f5;
    protected tk(): void;
    protected c3(seriesType_: DataSeriesType): Series;
    private cv;
    private cx;
    private cz;
    private c0;
    private cw;
    private cy;
    private c2;
    private b2;
    protected get b3(): IAnnotationLayerProxy;
    private get fw();
    private fy;
    private ts;
    protected f1(): boolean;
    protected f2(): boolean;
    protected get_fz(): boolean;
    protected get fz(): boolean;
    protected gp(a: string, b: boolean): List$1<Series>;
    protected ro(a: Series, b: boolean): void;
    protected tq(a: Series, b: Series, c: DataSeries): void;
    protected abstract tj(a: DataSeries): void;
    protected abstract ti(a: DataSeries): void;
    protected tm(): void;
    private tn;
    protected to(a: Series): void;
    protected abstract tl(): void;
    private st;
    protected rs(): void;
    protected u3(a: number): Brush;
    protected u6(a: number): Brush;
    protected u4(a: number): Brush;
    protected u5(a: number): Brush;
    protected ve(a: number): Color;
    protected em(a: Color): ObservableColorCollection;
    protected ac(a: Color): BrushCollection;
    protected gm: List$1<Color>;
    protected get go(): List$1<Color>;
    protected get_gg(): boolean;
    protected get gg(): boolean;
    kb(): any;
    sh(a: string, b: string): void;
    si(a: string, b: string, c: Series): void;
    cp(a: DataSeriesMarker): MarkerType;
    private b6;
    private e6;
    attachDataLegend(a: IDataLegend): void;
    protected rn(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    protected rr(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    protected p(): IDataLegendSeries[];
    tt(a: number): void;
    tu(a: number): void;
    tp(): void;
    protected get_f8(): boolean;
    get f8(): boolean;
    private b7;
    get b8(): IDomainChartToolbarProvider;
    private sz;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private sg;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private gk;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    sn(source_: any, a: number, b: any, c: any): void;
    sj(source_: any): void;
    sk(source_: any, a: number, b: any): void;
    sl(source_: any, a: number, b: any): void;
    private bu;
    get bv(): DataToolTipLayerGroupingMode;
    set bv(a: DataToolTipLayerGroupingMode);
    private g3;
    get ie(): number;
    set ie(a: number);
    private g4;
    get ig(): number;
    set ig(a: number);
    private g1;
    get ic(): number;
    set ic(a: number);
    private g2;
    get id(): number;
    set id(a: number);
    private bq;
    get br(): DataTooltipGroupedPositionX;
    set br(a: DataTooltipGroupedPositionX);
    private bs;
    get bt(): DataTooltipGroupedPositionY;
    set bt(a: DataTooltipGroupedPositionY);
    private ex;
    get fr(): boolean;
    set fr(a: boolean);
    static readonly m1: string;
    get m(): string[];
    set m(a: string[]);
    private e;
    get j(): string[];
    set j(a: string[]);
    private b;
    get l(): string[];
    set l(a: string[]);
    private d;
    get i(): string[];
    set i(a: string[]);
    private a;
    get bb(): DataAbbreviationMode;
    set bb(a: DataAbbreviationMode);
    private ba;
    get jz(): number;
    set jz(a: number);
    private jq;
    get j0(): number;
    set j0(a: number);
    private jr;
    get bp(): DataLegendValueMode;
    set bp(a: DataLegendValueMode);
    private bo;
    get nt(): string;
    set nt(a: string);
    private kw;
    get fs(): boolean;
    set fs(a: boolean);
    private ey;
    get nz(): string;
    set nz(a: string);
    private kx;
    get n(): any[];
    set n(a: any[]);
    private f;
    get v0(): Thickness;
    set v0(a: Thickness);
    private vq;
    get ft(): boolean;
    set ft(a: boolean);
    private ez;
    get n8(): string;
    set n8(a: string);
    private ky;
    get fu(): boolean;
    set fu(a: boolean);
    private e0;
    get v1(): Thickness;
    set v1(a: Thickness);
    private vr;
    get u0(): Brush;
    set u0(a: Brush);
    private ud;
    private ec;
    get el(): FontInfo;
    set el(a: FontInfo);
    get mj(): string;
    set mj(a: string);
    private kq;
    get k(): any[];
    set k(a: any[]);
    private c;
    get mf(): string;
    set mf(a: string);
    private kp;
    get bf(): DataLegendHeaderDateMode;
    set bf(a: DataLegendHeaderDateMode);
    private be;
    get bh(): DataLegendHeaderTimeMode;
    set bh(a: DataLegendHeaderTimeMode);
    private bg;
    get mo(): string;
    set mo(a: string);
    private kr;
    get us(): Brush;
    set us(a: Brush);
    private t5;
    get vu(): Thickness;
    set vu(a: Thickness);
    private vk;
    get vt(): Thickness;
    set vt(a: Thickness);
    private vj;
    get fq(): boolean;
    set fq(a: boolean);
    private ew;
    private d4;
    get ed(): FontInfo;
    set ed(a: FontInfo);
    get uv(): Brush;
    set uv(a: Brush);
    private t8;
    private d7;
    get eg(): FontInfo;
    set eg(a: FontInfo);
    get bl(): DataLegendSummaryType;
    set bl(a: DataLegendSummaryType);
    private bk;
    get m7(): string;
    set m7(a: string);
    private kt;
    get vx(): Thickness;
    set vx(a: Thickness);
    private vn;
    get vw(): Thickness;
    set vw(a: Thickness);
    private vm;
    get ux(): Brush;
    set ux(a: Brush);
    private ua;
    private d9;
    get ei(): FontInfo;
    set ei(a: FontInfo);
    get m2(): string;
    set m2(a: string);
    private ks;
    get uu(): Brush;
    set uu(a: Brush);
    private t7;
    private d6;
    get ef(): FontInfo;
    set ef(a: FontInfo);
    get nd(): string;
    set nd(a: string);
    private ku;
    get uw(): Brush;
    set uw(a: Brush);
    private t9;
    private d8;
    get eh(): FontInfo;
    set eh(a: FontInfo);
    get vs(): Thickness;
    set vs(a: Thickness);
    private vi;
    get ch(): LegendItemBadgeShape;
    set ch(a: LegendItemBadgeShape);
    private cf;
    get bn(): DataLegendUnitsMode;
    set bn(a: DataLegendUnitsMode);
    private bm;
    get nn(): string;
    set nn(a: string);
    private kv;
    get uz(): Brush;
    set uz(a: Brush);
    private uc;
    get vz(): Thickness;
    set vz(a: Thickness);
    private vp;
    private eb;
    get ek(): FontInfo;
    set ek(a: FontInfo);
    get vy(): Thickness;
    set vy(a: Thickness);
    private vo;
    get uy(): Brush;
    set uy(a: Brush);
    private ub;
    private ea;
    get ej(): FontInfo;
    set ej(a: FontInfo);
    get bj(): DataLegendLabelMode;
    set bj(a: DataLegendLabelMode);
    private bi;
    get ut(): Brush;
    set ut(a: Brush);
    private t6;
    get vv(): Thickness;
    set vv(a: Thickness);
    private vl;
    private d5;
    get ee(): FontInfo;
    set ee(a: FontInfo);
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    s9(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    tf(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    tb(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    tc(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    td(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    ta(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    te(a: Series, b: any): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    s7(a: any, b: CalloutStyleUpdatingEventArgs): void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    s6(a: any, b: CalloutRenderStyleUpdatingEventArgs): void;
    private gq;
    s4(a: () => void): void;
    private en;
    s5(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_ga(): boolean;
    protected get ga(): boolean;
    protected r6(a: XamDataChart): void;
    protected ag(a: BrushCollection): BrushCollection;
    protected u9(a: Brush): Brush;
    protected sc(a: Series, b: number): void;
    protected abstract rp(): void;
    protected get fk(): boolean;
    private eq;
    protected rt(): void;
    protected r3(): void;
    protected tg(a: XamDataChart): void;
    protected rm(a: Series, b: number): void;
    protected abstract rl(a: Series, b: number): void;
    protected cr(a: Series, b: number): MarkerType;
    protected cq(a: Series): MarkerType;
    protected cs(a: Series): MarkerType;
    protected kf(): any;
    protected get_f3(): boolean;
    protected get f3(): boolean;
    protected gx(): IEnumerable;
    protected sy(a: string, b: any, c: any): void;
    private gj;
    private gl;
    private su;
    private rk;
    private sw;
    private s0;
    abstract get b1(): DomainType;
    private au;
    private aq;
    private ap;
    private dx;
    private a2;
    private d0;
    private d1;
    private fe;
    private fd;
    private ff;
    private fc;
    private at;
    private as;
    private ar;
    private dy;
    private a1;
    get a0(): ChartSortDescriptionCollection;
    get aw(): ChartSortDescriptionCollection;
    get av(): ChartSortDescriptionCollection;
    get dz(): FilterExpressionCollection;
    get a4(): ChartSummaryDescriptionCollection;
    get az(): ChartSortDescriptionCollection;
    get ay(): ChartSortDescriptionCollection;
    get ax(): ChartSortDescriptionCollection;
    get a3(): ChartSummaryDescriptionCollection;
    private k1;
    get o1(): string;
    set o1(a: string);
    private kz;
    get oi(): string;
    set oi(a: string);
    private k0;
    get oz(): string;
    set oz(a: string);
    private k2;
    get o3(): string;
    set o3(a: string);
    private j6;
    get itemsSource(): any;
    set itemsSource(a: any);
    private j5;
    get actualItemsSource(): any;
    set actualItemsSource(a: any);
    private h;
    get q(): string[];
    set q(a: string[]);
    private g;
    get o(): string[];
    set o(a: string[]);
    private t;
    get ab(): BrushCollection;
    set ab(a: BrushCollection);
    private w;
    get af(): BrushCollection;
    set af(a: BrushCollection);
    private r;
    get z(): BrushCollection;
    set z(a: BrushCollection);
    private s;
    get aa(): BrushCollection;
    set aa(a: BrushCollection);
    private b4;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private e5;
    protected get_f4(): boolean;
    protected set_f4(a: boolean): void;
    get f4(): boolean;
    set f4(a: boolean);
    private e8;
    protected get_gb(): boolean;
    protected set_gb(a: boolean): void;
    get gb(): boolean;
    set gb(a: boolean);
    private fa;
    protected get_ge(): boolean;
    protected set_ge(a: boolean): void;
    get ge(): boolean;
    set ge(a: boolean);
    private fg;
    protected get_gh(): boolean;
    protected set_gh(a: boolean): void;
    get gh(): boolean;
    set gh(a: boolean);
    private e7;
    protected get_f6(): boolean;
    protected set_f6(a: boolean): void;
    get f6(): boolean;
    set f6(a: boolean);
    private vf;
    get vh(): Rect;
    set vh(a: Rect);
    get vg(): Rect;
    private k5;
    get qd(): string;
    set qd(a: string);
    private k3;
    get p2(): string;
    set p2(a: string);
    private tw;
    get ty(): HorizontalAlignment;
    set ty(a: HorizontalAlignment);
    private tv;
    get tx(): HorizontalAlignment;
    set tx(a: HorizontalAlignment);
    private dr;
    get ds(): UnknownValuePlotting;
    set ds(a: UnknownValuePlotting);
    private hk;
    protected get_ix(): number;
    protected set_ix(a: number): void;
    get ix(): number;
    set ix(a: number);
    private hq;
    get i3(): number;
    set i3(a: number);
    private c8;
    get c9(): SeriesOutlineMode;
    set c9(a: SeriesOutlineMode);
    private cn;
    get co(): MarkerOutlineMode;
    set co(a: MarkerOutlineMode);
    private cl;
    get cm(): MarkerFillMode;
    set cm(a: MarkerFillMode);
    private hd;
    get iq(): number;
    set iq(a: number);
    private he;
    get ir(): number;
    set ir(a: number);
    private ct;
    get cu(): MarkerTypeCollection;
    set cu(a: MarkerTypeCollection);
    private cj;
    get ck(): MarkerAutomaticBehavior;
    set ck(a: MarkerAutomaticBehavior);
    private u;
    get ad(): BrushCollection;
    set ad(a: BrushCollection);
    private v;
    get ae(): BrushCollection;
    set ae(a: BrushCollection);
    private jt;
    get j2(): number;
    set j2(a: number);
    private gy;
    get h9(): number;
    set h9(a: number);
    private ep;
    get fj(): boolean;
    set fj(a: boolean);
    private x;
    get ah(): BrushCollection;
    set ah(a: BrushCollection);
    private dp;
    get dq(): TrendLineType;
    set dq(a: TrendLineType);
    private hw;
    get i9(): number;
    set i9(a: number);
    private eo;
    get fi(): boolean;
    set fi(a: boolean);
    private hh;
    get iu(): number;
    set iu(a: number);
    private hj;
    get iw(): number;
    set iw(a: number);
    private hi;
    get iv(): number;
    set iv(a: number);
    private hg;
    get it(): number;
    set it(a: number);
    protected sx(): void;
    private a5;
    get a6(): ComputedPlotAreaMarginMode;
    set a6(a: ComputedPlotAreaMarginMode);
    protected a7(): ComputedPlotAreaMarginMode;
    private da;
    get db(): SeriesPlotAreaMarginHorizontalMode;
    set db(a: SeriesPlotAreaMarginHorizontalMode);
    private dc;
    get dd(): SeriesPlotAreaMarginVerticalMode;
    set dd(a: SeriesPlotAreaMarginVerticalMode);
    private c6;
    get c7(): SeriesHighlightingMode;
    set c7(a: SeriesHighlightingMode);
    private c4;
    get c5(): SeriesHighlightingBehavior;
    set c5(a: SeriesHighlightingBehavior);
    private cb;
    get cc(): LegendHighlightingMode;
    set cc(a: LegendHighlightingMode);
    private cg;
    get ci(): LegendItemBadgeShape;
    set ci(a: LegendItemBadgeShape);
    private cd;
    get ce(): LegendItemBadgeMode;
    set ce(a: LegendItemBadgeMode);
    private jw;
    get j4(): number;
    set j4(a: number);
    private dm;
    get dn(): ToolTipType;
    set dn(a: ToolTipType);
    private a8;
    get a9(): CrosshairsDisplayMode;
    set a9(a: CrosshairsDisplayMode);
    private ev;
    get fp(): boolean;
    set fp(a: boolean);
    private t4;
    get ur(): Brush;
    set ur(a: Brush);
    private g0;
    get ib(): number;
    set ib(a: number);
    private t3;
    get uq(): Brush;
    set uq(a: Brush);
    private eu;
    get fo(): boolean;
    set fo(a: boolean);
    private tz;
    get um(): Brush;
    set um(a: Brush);
    private t1;
    get uo(): Brush;
    set uo(a: Brush);
    private t0;
    get un(): Brush;
    set un(a: Brush);
    private t2;
    get up(): Brush;
    set up(a: Brush);
    private jo;
    get jx(): number;
    set jx(a: number);
    private jp;
    get jy(): number;
    set jy(a: number);
    private e9;
    get gd(): boolean;
    set gd(a: boolean);
    private fb;
    get gf(): boolean;
    set gf(a: boolean);
    private e1;
    get fv(): boolean;
    set fv(a: boolean);
    private ue;
    get u1(): Brush;
    set u1(a: Brush);
    private uf;
    get u2(): Brush;
    set u2(a: Brush);
    private js;
    get j1(): number;
    set j1(a: number);
    private er;
    get fl(): boolean;
    set fl(a: boolean);
    private et;
    get fn(): boolean;
    set fn(a: boolean);
    private es;
    get fm(): boolean;
    set fm(a: boolean);
    private gv;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private aj;
    get ak(): CalloutPlacementPositionsCollection;
    set ak(a: CalloutPlacementPositionsCollection);
    private kn;
    get lo(): string;
    set lo(a: string);
    private ko;
    get lq(): string;
    set lq(a: string);
    private km;
    get lk(): string;
    set lk(a: string);
    private kl;
    get lh(): string;
    set lh(a: string);
    private dt;
    get du(): ValueModeCollection;
    set du(a: ValueModeCollection);
    private y;
    get ai(): BrushCollection;
    set ai(a: BrushCollection);
    private hx;
    get ja(): number;
    set ja(a: number);
    get di(): SeriesViewerScrollbarMode;
    set di(a: SeriesViewerScrollbarMode);
    private dg;
    get dj(): SeriesViewerScrollbarMode;
    set dj(a: SeriesViewerScrollbarMode);
    private dh;
    get df(): SeriesViewerHorizontalScrollbarPosition;
    set df(a: SeriesViewerHorizontalScrollbarPosition);
    private de;
    get dl(): SeriesViewerVerticalScrollbarPosition;
    set dl(a: SeriesViewerVerticalScrollbarPosition);
    private dk;
    get u7(): Brush;
    set u7(a: Brush);
    private ug;
    get u8(): Brush;
    set u8(a: Brush);
    private uh;
    get il(): number;
    set il(a: number);
    private g9;
    get ik(): number;
    set ik(a: number);
    private g8;
    get ih(): number;
    set ih(a: number);
    private g5;
    get ii(): number;
    set ii(a: number);
    private g6;
    get ij(): number;
    set ij(a: number);
    private g7;
    get io(): number;
    set io(a: number);
    private hb;
    get im(): number;
    set im(a: number);
    private ha;
    get fx(): boolean;
    set fx(a: boolean);
    private e2;
    static readonly ou: string;
    get vc(): Brush;
    set vc(a: Brush);
    private uk;
    get vd(): Brush;
    set vd(a: Brush);
    private ul;
    get je(): number;
    set je(a: number);
    private h1;
    get jd(): number;
    set jd(a: number);
    private h0;
    get jb(): number;
    set jb(a: number);
    private hy;
    get jh(): number;
    set jh(a: number);
    private h4;
    get jc(): number;
    set jc(a: number);
    private hz;
    get jg(): number;
    set jg(a: number);
    private h3;
    get jf(): number;
    set jf(a: number);
    private h2;
    get gi(): boolean;
    set gi(a: boolean);
    private fh;
    static readonly q9: string;
    get jj(): number;
    set jj(a: number);
    private h6;
    get ji(): number;
    set ji(a: number);
    private h5;
    get jl(): number;
    set jl(a: number);
    private h8;
    get jk(): number;
    set jk(a: number);
    private h7;
}
/**
 * @hidden
 */
export interface IDomainChartToolbarProvider {
    container: any;
    commandChanged: (arg1: ToolCommandStateChanged) => void;
    getDesiredToolbarActions(a: DomainChart, b: ToolActionInfo[]): ToolActionInfo[];
    onToolCommandExecuting(a: DomainChart, b: ToolCommand): ToolCommandExecutionState;
    onTargetPropertyChanged(a: DomainChart, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare let IDomainChartToolbarProvider_$type: Type;
