import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected sb(): void;
    protected s1(a: string, b: any, c: any): void;
    private v8;
    get wa(): (item: any) => string;
    set wa(a: (item: any) => string);
    private v9;
    get wb(): (item: any) => string;
    set wb(a: (item: any) => string);
    private wp;
    get xr(): number;
    set xr(a: number);
    private wr;
    get xt(): number;
    set xt(a: number);
    private wq;
    get xs(): number;
    set xs(a: number);
    private wo;
    get xq(): number;
    set xq(a: number);
    private w6;
    get x8(): number;
    set x8(a: number);
    private w8;
    get ya(): number;
    set ya(a: number);
    private w7;
    get x9(): number;
    set x9(a: number);
    private w5;
    get x7(): number;
    set x7(a: number);
    private abz;
    get acf(): Brush;
    set acf(a: Brush);
    private ab6;
    get acm(): Brush;
    set acm(a: Brush);
    private abx;
    get acd(): Brush;
    set acd(a: Brush);
    private aby;
    get ace(): Brush;
    set ace(a: Brush);
    private w0;
    get x2(): number;
    set x2(a: number);
    private xh;
    get yj(): number;
    set yj(a: number);
    private wz;
    get x1(): number;
    set x1(a: number);
    private xg;
    get yi(): number;
    set yi(a: number);
    private w2;
    get x4(): number;
    set x4(a: number);
    private xj;
    get yl(): number;
    set yl(a: number);
    private w1;
    get x3(): number;
    set x3(a: number);
    private xi;
    get yk(): number;
    set yk(a: number);
    private wy;
    get x0(): number;
    set x0(a: number);
    private xf;
    get yh(): number;
    set yh(a: number);
    private ab5;
    get acl(): Brush;
    set acl(a: Brush);
    private acc;
    get acs(): Brush;
    set acs(a: Brush);
    protected s2(a: string, b: any, c: any): void;
    private yr;
    get zf(): string;
    set zf(a: string);
    private yv;
    get aak(): string;
    set aak(a: string);
    private yt;
    get z3(): string;
    set z3(a: string);
    private yx;
    get aa8(): string;
    set aa8(a: string);
    private abe;
    private abg;
    protected tj(a: DataSeries): void;
    protected abstract v6(): Axis;
    protected abstract v7(): Axis;
    protected abh(a: (arg1: Axis) => void): void;
    protected abi(a: (arg1: Axis) => void, b: string): void;
    protected abn(a: (arg1: Axis) => void, b: boolean): void;
    protected abm(a: (arg1: Axis) => void): void;
    protected rv(a: (arg1: Axis) => void, b: boolean): void;
    protected abl(a: (arg1: TitleSettings) => void): void;
    protected abq(a: (arg1: TitleSettings) => void): void;
    protected abo(a: (arg1: AxisLabelSettings) => void): void;
    protected abj(a: (arg1: AxisLabelSettings) => void): void;
    xk(a: number): number;
    xm(a: number): number;
    xl(a: number): number;
    xn(a: number): number;
    protected tg(a: XamDataChart): void;
    static y0(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected r6(a: XamDataChart): void;
    protected abd(a: Axis): void;
    protected abf(a: Axis): void;
    protected r3(): void;
    protected abb(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected abc(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected sy(a: string, b: any, c: any): void;
    abp(): void;
    abk(): void;
    wd(a: YAxisLabelLocation): AxisLabelsLocation;
    wc(a: XAxisLabelLocation): AxisLabelsLocation;
    private ym;
    get yo(): any;
    set yo(a: any);
    private yn;
    get yp(): any;
    set yp(a: any);
    private ab0;
    get acg(): Brush;
    set acg(a: Brush);
    private ab7;
    get acn(): Brush;
    set acn(a: Brush);
    private ws;
    get xu(): number;
    set xu(a: number);
    private w9;
    get yb(): number;
    set yb(a: number);
    private wt;
    get xv(): number;
    set xv(a: number);
    private xa;
    get yc(): number;
    set yc(a: number);
    private ab2;
    get aci(): Brush;
    set aci(a: Brush);
    private ab9;
    get acp(): Brush;
    set acp(a: Brush);
    private ab3;
    get acj(): Brush;
    set acj(a: Brush);
    private aca;
    get acq(): Brush;
    set acq(a: Brush);
    private wu;
    get xw(): number;
    set xw(a: number);
    private xb;
    get yd(): number;
    set yd(a: number);
    private wv;
    get xx(): number;
    set xx(a: number);
    private xc;
    get ye(): number;
    set ye(a: number);
    private ab4;
    get ack(): Brush;
    set ack(a: Brush);
    private acb;
    get acr(): Brush;
    set acr(a: Brush);
    private ww;
    get xy(): number;
    set xy(a: number);
    private xd;
    get yf(): number;
    set yf(a: number);
    private ys;
    get zu(): string;
    set zu(a: string);
    private yw;
    get aaz(): string;
    set aaz(a: string);
    private ab1;
    get ach(): Brush;
    set ach(a: Brush);
    private ab8;
    get aco(): Brush;
    set aco(a: Brush);
    private wn;
    get xp(): number;
    set xp(a: number);
    private w4;
    get x6(): number;
    set x6(a: number);
    private wm;
    get xo(): number;
    set xo(a: number);
    private w3;
    get x5(): number;
    set x5(a: number);
    private wx;
    get xz(): number;
    set xz(a: number);
    private xe;
    get yg(): number;
    set yg(a: number);
    private wi;
    get wk(): boolean;
    set wk(a: boolean);
    private wj;
    get wl(): boolean;
    set wl(a: boolean);
    private abs;
    get abv(): HorizontalAlignment;
    set abv(a: HorizontalAlignment);
    private acv;
    get acy(): VerticalAlignment;
    set acy(a: VerticalAlignment);
    private abr;
    get abu(): HorizontalAlignment;
    set abu(a: HorizontalAlignment);
    private abt;
    protected get_abw(): HorizontalAlignment;
    protected set_abw(a: HorizontalAlignment): void;
    get abw(): HorizontalAlignment;
    set abw(a: HorizontalAlignment);
    private act;
    get acw(): VerticalAlignment;
    set acw(a: VerticalAlignment);
    private acu;
    get acx(): VerticalAlignment;
    set acx(a: VerticalAlignment);
    private acz;
    get ac1(): Visibility;
    set ac1(a: Visibility);
    private ac0;
    get ac2(): Visibility;
    set ac2(a: Visibility);
    private wg;
    protected get_wh(): YAxisLabelLocation;
    protected set_wh(a: YAxisLabelLocation): void;
    get wh(): YAxisLabelLocation;
    set wh(a: YAxisLabelLocation);
    private we;
    protected get_wf(): XAxisLabelLocation;
    protected set_wf(a: XAxisLabelLocation): void;
    get wf(): XAxisLabelLocation;
    set wf(a: XAxisLabelLocation);
    private yq;
    get y6(): string;
    set y6(a: string);
    private v2;
    get v4(): any[];
    set v4(a: any[]);
    private yu;
    get aab(): string;
    set aab(a: string);
    private v3;
    get v5(): any[];
    set v5(a: any[]);
}
